/*
 *
 * fieldday front end Javascript
 *
 * @since 1.0.0
 *
 */
var fieldday;
(function ($) {
    var $this, $currentstep, $totalkids, $timerOn, $timer, $otptimer, $isKmUser, $minstepnumber, $maxstepnumber, widgetId, AtcsessionId, AtctagId, AtcsessionDate, AtcOfferId, $state, $code, $typingTimer;
    fieldday = {
        settings: {
            loader: '<div class="km_loader_full"></div>',
            spinnerInline: '<i class="fa fa-spinner fa-spin wpforms-loading-inline"></i>',
            DaysArray: ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'],
            allCountries: {
                "93": "af",
                "355": "al",
                "213": "dz",
                "1": "us",
                "376": "ad",
                "244": "ao",
                "54": "ar",
                "374": "am",
                "297": "aw",
                "61": "cc",
                "43": "at",
                "994": "az",
                "973": "bh",
                "880": "bd",
                "375": "by",
                "32": "be",
                "501": "bz",
                "229": "bj",
                "975": "bt",
                "591": "bo",
                "387": "ba",
                "267": "bw",
                "55": "br",
                "246": "io",
                "673": "bn",
                "359": "bg",
                "226": "bf",
                "257": "bi",
                "855": "kh",
                "237": "cm",
                "238": "cv",
                "599": "cw",
                "236": "cf",
                "235": "td",
                "56": "cl",
                "86": "cn",
                "57": "co",
                "269": "km",
                "243": "cd",
                "242": "cg",
                "682": "ck",
                "506": "cr",
                "225": "ci",
                "385": "hr",
                "53": "cu",
                "357": "cy",
                "420": "cz",
                "45": "dk",
                "253": "dj",
                "593": "ec",
                "20": "eg",
                "503": "sv",
                "240": "gq",
                "291": "er",
                "372": "ee",
                "251": "et",
                "500": "fk",
                "298": "fo",
                "679": "fj",
                "358": "ax",
                "33": "fr",
                "594": "gf",
                "689": "pf",
                "241": "ga",
                "220": "gm",
                "995": "ge",
                "49": "de",
                "233": "gh",
                "350": "gi",
                "30": "gr",
                "299": "gl",
                "590": "mf",
                "502": "gt",
                "44": "gb",
                "224": "gn",
                "245": "gw",
                "592": "gy",
                "509": "ht",
                "504": "hn",
                "852": "hk",
                "36": "hu",
                "354": "is",
                "91": "in",
                "62": "id",
                "98": "ir",
                "964": "iq",
                "353": "ie",
                "972": "il",
                "39": "va",
                "81": "jp",
                "962": "jo",
                "7": "ru",
                "254": "ke",
                "686": "ki",
                "383": "xk",
                "965": "kw",
                "996": "kg",
                "856": "la",
                "371": "lv",
                "961": "lb",
                "266": "ls",
                "231": "lr",
                "218": "ly",
                "423": "li",
                "370": "lt",
                "352": "lu",
                "853": "mo",
                "389": "mk",
                "261": "mg",
                "265": "mw",
                "60": "my",
                "960": "mv",
                "223": "ml",
                "356": "mt",
                "692": "mh",
                "596": "mq",
                "222": "mr",
                "230": "mu",
                "262": "re",
                "52": "mx",
                "691": "fm",
                "373": "md",
                "377": "mc",
                "976": "mn",
                "382": "me",
                "212": "eh",
                "258": "mz",
                "95": "mm",
                "264": "na",
                "674": "nr",
                "977": "np",
                "31": "nl",
                "687": "nc",
                "64": "nz",
                "505": "ni",
                "227": "ne",
                "234": "ng",
                "683": "nu",
                "672": "nf",
                "850": "kp",
                "47": "sj",
                "968": "om",
                "92": "pk",
                "680": "pw",
                "970": "ps",
                "507": "pa",
                "675": "pg",
                "595": "py",
                "51": "pe",
                "63": "ph",
                "48": "pl",
                "351": "pt",
                "974": "qa",
                "40": "ro",
                "250": "rw",
                "290": "sh",
                "508": "pm",
                "685": "ws",
                "378": "sm",
                "239": "st",
                "966": "sa",
                "221": "sn",
                "381": "rs",
                "248": "sc",
                "232": "sl",
                "65": "sg",
                "421": "sk",
                "386": "si",
                "677": "sb",
                "252": "so",
                "27": "za",
                "82": "kr",
                "211": "ss",
                "34": "es",
                "94": "lk",
                "249": "sd",
                "597": "sr",
                "268": "sz",
                "46": "se",
                "41": "ch",
                "963": "sy",
                "886": "tw",
                "992": "tj",
                "255": "tz",
                "66": "th",
                "670": "tl",
                "228": "tg",
                "690": "tk",
                "676": "to",
                "216": "tn",
                "90": "tr",
                "993": "tm",
                "688": "tv",
                "256": "ug",
                "380": "ua",
                "971": "ae",
                "598": "uy",
                "998": "uz",
                "678": "vu",
                "58": "ve",
                "84": "vn",
                "681": "wf",
                "967": "ye",
                "260": "zm",
                "263": "zw"
            },
            parsley_valiation_options: {
                trigger: 'change',
                successClass: "has-success",
                errorClass: "has-error",
                classHandler: function (el) {
                    return el.$element.closest('fieldset'); //working
                },
                errorsWrapper: '<div class="km_invalid_message"></div>',
                errorTemplate: '<span></span>'
            },
            parsley_valiation_options_register: {
                trigger: 'change',
                successClass: "has-success",
                errorClass: "has-error",
                classHandler: function (el) {
                    return el.$element.closest('fieldset'); //working
                },
                errorsWrapper: '<div class="km_auth_invalid_message"></div>',
                errorTemplate: '<span></span>'
            }
        },
        initilaize: function () {
            $this = fieldday;
            $currentstep = 0;
            $otptimer = 120;
            $timerOn = true;
            $minstepnumber = 1;
            $maxstepnumber = 5;
            $isKmUser = fieldday_ajax.isKmUser;
            $(document).ready(function () {
                $this.onInitMethods();
            });
            /* clear session filter when user click browser back button */
            $this.ClearSessionFilters('.km_filter_form');

        },
        onInitMethods: function () {
            $this.FilterSessions();
            $this.fielddaySessionTime();
            $this.InitSessionFilter();
            $this.PhoneInput();
            $this.CardInput();
            $this.triggerModal();
            $this.handleQueryParam();
            $this.atc_cart_steps();
            $this.requiredfields();
            $this.checkoutpageevents();
            $this.merchandiseevents();
            $this.kidspageevents();
            $this.SessionlistVeiw();
            $this.Myaccountpageevents();
            $this.getTimezoneOffset();
            $this.kmTooltip();
            $this.otpEvents();
            $this.fielddaySelect();
            $this.hasCart();
            $this.countItmeCart();
            $this.initilaizeDaterangepicker();
            $this.ModalCalander();
            $this.giftCardswitchevent();
            $this.passwordHideShowevent();
            /* set stripe publishing key*/
            Stripe.setPublishableKey(fieldday_ajax.fieldday_stripe_token);
            $this.paymentrequired = false;
            var bankdays = document.URL.split('=')[1];
            if (bankdays == "bank_days") {
                $('.km_merchandise').attr('checked', true);
                $('.km_merchandise').trigger("change");
            }
        },
        getDaysBetweenDates: function (startDate, endDate) {
            var now = startDate.clone(), dates = [];

            while (now.isSameOrBefore(endDate)) {
                dates.push(now.format('MM/DD/YYYY'));
                now.add(1, 'days');
            }
            return dates;
        },
        ModalCalander: function () {
            $(".km_datepicker").on('click', function () {
                let header = $(this).data('modal-heading');
                var dateFrom = $(this).data('date-from');
                var dateTo = $(this).data('date-to');
                $this.displayModal({header: header, content: "<div class='km_calander_div'></div>", footer: ""});
                var startDate = moment(dateFrom);
                var endDate = moment(dateTo);
                var dateList = $this.getDaysBetweenDates(startDate, endDate);

                $('.km_calander_div').datepicker({
                    format: 'mm-dd-yyyy',
                    minDate: new Date(dateFrom),
                    maxDate: new Date(dateTo),
                    beforeShowDay: function (date) {
                        var year = date.getFullYear(), month = date.getMonth(), day = date.getDate();
                        // see if the current date should be highlighted
                        for (var i = 0; i < dateList.length; ++i) {
                            let date = new Date(dateList[i]);
                            //console.log(date.getFullYear());
                            if (year == date.getFullYear() && month == date.getMonth() - 1 && day == date.getDate()) {
                                return [true, 'ui-state-highlight ui-state-active'];
                            }
                        }

                        return [false];
                    }
                });
            });

        },
        triggerModal: function () {
            $('.km_modal_link').on('click', function (e) {
                e.preventDefault();
                let modelTitle = $(this).data('title');
                let modeldescription = $(this).data('description');
                $this.displayModal({header: modelTitle, content: "<div class='km_wrapped_content'>" + modeldescription + "</div>"}, 'km_modal_small km_custom_trigger_popup');
            });
        },
        kmTooltip: function () {
            $(".km_session_location").mouseenter(function () {
                $(this).next('.km_sessions_description').show();
            });
            $(".km_session_location").mouseleave(function () {
                $(this).next('.km_sessions_description').hide();
            });

            $(document).on("mouseenter", ".km_tooltip", function () {
                var text = $(this).data('tooltip-title');
                $(this).append('<i>' + text + '</i>');
            });
            $(document).on("mouseleave", ".km_tooltip", function () {
                $('.km_tooltip i').remove();
            });
        },
        handleQueryParam: function () {
            $state = $this.GetQueryString('state');
            if ($state) {
                $code = $this.GetQueryString('code');
                var statevar = $state.split('_');

                var uri = window.location.href.toString();
                if (uri.indexOf("?") > 0) {
                    var clean_uri = uri.substring(0, uri.indexOf("?"));
                    window.history.replaceState({}, document.title, clean_uri);
                }
                if (statevar[0] == 'facebook') {
                    $this.LoginWithFacebook();
                } else if (statevar[0] == 'google') {
                    $this.LoginWithGoogle();
                }
            }
            let $sessionId = $this.GetQueryString('sessionId');
            if ($sessionId) {
                $this.viewSessionDetail($sessionId);
            }

        },
        fielddaySelect: function () {
            $(".fieldday_select").select2();
        },
        fielddaySelectDestroy: function () {
            $(".fieldday_select").select2('destroy');
        },
        requiredfields: function () {
            $("input[required]:not(.optional), select[required]:not(.optional), textarea[required]:not(.optional)").each(function () {
                $(this).parents('.km_field_wrap').addClass('required_field');
            });
        },
        closepopup: function () {
            $('#km_modal').hide();
            $('#km_modal .km_modal_heading, #km_modal .km_modal_content, #km_modal .km_modal_footer').html('');
            let sessionId = $this.GetQueryString('sessionId');
            if (sessionId) {
                $this.removeQueryParam('sessionId');
            }
        },
        closediscountpopup: function (element) {
            $(element).parents('.km_modal').hide();
        },
        showAuthPopup: function (button, event) {
            if ($isKmUser) {
                location.reload();
            }
            event.preventDefault();
            var isGuest = $('a.km_btn.km_feature_purchase_btn').data('isguest');
            var formdata = {
                action: 'km_display_auth',
                'isGuest': isGuest
            };
            var sessionId = $(button).data('session-id');
            var sessionfeatured = $(button).data('session-featured');
            var offerId = $(button).data('offer-id');
            if (sessionId) {
                var tagId = $(button).data('tag-id');
                var sessionDate = $(button).data('session-date');
                formdata.session_id = sessionId;
                formdata.tagId = tagId;
                formdata.session_date = sessionDate;
                formdata.sessionfeatured = sessionfeatured;
                formdata.isGuest = isGuest;
                AtcsessionId = sessionId;
                AtctagId = tagId;
                AtcsessionDate = sessionDate;

            }

            if (offerId) {
                formdata.offerId = offerId;
                AtcOfferId = offerId;
            }

            $this.makeCall(fieldday_ajax.ajax_url, formdata, function (response) {
                $this.displayModal(response, 'modal-large');
            });
        },
        showLoginForm: function (button, event) {
            if ($isKmUser) {
                location.reload();
            }
            event.preventDefault();
            var sessionfeatured = $(button).data('session-featured');
            var sessionDate = $(button).data('session-date');
            var isGuest = $(button).data('session-isguest');

            var formdata = {
                action: 'km_display_login',
                'sessionfeatured': sessionfeatured,
                'session_date': sessionDate,
                'isGuest': isGuest,
            };
            var sessionId = $(button).data('session-id');
            var offerId = $(button).data('offer-id');
            var sessionfeatured = $(button).data('session-featured');
            if (sessionId) {
                var tagId = $(button).data('tag-id');
                var sessionDate = $(button).data('session-date');
                formdata.session_id = sessionId;
                formdata.tagId = tagId;
                formdata.session_date = sessionDate;
                formdata.sessionfeatured = sessionfeatured;
                AtcsessionId = sessionId;
                AtctagId = tagId;
                AtcsessionDate = sessionDate;

            }

            if (offerId) {
                formdata.offerId = offerId;
                AtcOfferId = offerId;
            }
            $this.makeCall(fieldday_ajax.ajax_url, formdata, function (response) {
                $this.displayModal(response, 'modal-large');
                $('.km_modal_content .km_login_wrap').addClass('km_ajax_login');
                $('.km_signup_wrap:not(.km_ajax_signup_wrap)').hide();
                $('.km_ajax_signup_wrap').removeClass('km_hidden');
                widgetId = grecaptcha.render("g-recaptcha", {
                    sitekey: fieldday_ajax.g_sitekey,
                });


            });
        },
        showRegisterForm: function (button, event) {
            var formdata = {
                action: 'km_display_register'
            };
            var sessionId = $(button).data('session-id');
            var offerId = $(button).data('offer-id');
            var sessionfeatured = $(button).data('session-featured');
            if (sessionId) {
                var tagId = $(button).data('tag-id');
                var sessionDate = $(button).data('session-date');
                formdata.session_id = sessionId;
                formdata.tagId = tagId;
                formdata.session_date = sessionDate;
                formdata.session_date = sessionfeatured;
                AtcsessionId = sessionId;
                AtctagId = tagId;
                AtcsessionDate = sessionDate;
            }

            if (offerId) {
                formdata.offerId = offerId;
                AtcOfferId = offerId;
            }
            $this.makeCall(fieldday_ajax.ajax_url, formdata, function (response) {
                $this.displayModal(response, 'modal-large');
                $('.km_modal_content .km_register_wrap').addClass('km_ajax_register');
                $('.km_signup_wrap:not(.km_ajax_signup_wrap)').hide();
                $('.km_ajax_signup_wrap').removeClass('km_hidden');
                $this.PhoneInput();
                widgetId = grecaptcha.render("g-recaptcha", {
                    sitekey: fieldday_ajax.g_sitekey,
                });
            });
        },
        showForgetPassword: function () {
            $this.makeCall(fieldday_ajax.ajax_url, {
                action: 'km_forget_popup'
            }, function (response) {
                if (response.status == 'success') {
                    $this.displayModal(response, 'modal-normal');
                } else {
                    $this.DisplayAlert('error', response.message);
                }
            });
        },
        forgetPassword: function (button, event) {
            event.preventDefault();
            $('#km_forget_password').parsley($this.settings.parsley_valiation_options).whenValidate({
                group: 'forgetPassword'
            }).done(function () {
                var formData = new FormData($('#km_forget_password')[0]);
                //formData.set('action', 'km_reset_password');
                $(button).prop('disabled', true);
                $this.postFormData(fieldday_ajax.ajax_url + "?action=km_reset_password", formData, function (response) {
                    if (response.status == 'success') {
                        $('#km_forget_password')[0].reset();
                        $this.DisplayMessage(button, 'success', response.message);
                    } else {
                        $this.DisplayMessage(button, 'error', response.message);
                    }
                    $(button).prop('disabled', false);
                });
            });
        },
        checkoutpageevents: function () {
            $(document).on('click', '.km_provider_terms_display', function (e) {
                e.preventDefault();
                $this.makeCall(fieldday_ajax.ajax_url, {
                    action: 'km_getprovider_terms'
                }, function (response) {
                    if (response.status == 'success') {
                        $this.displayModal(response, 'modal-large');
                    } else {
                        $this.DisplayAlert('error', response.message);
                    }
                });
            });
            $(document).on('change', '.km_provider_terms', function () {
                if ($(this).is(":checked")) {
                    $(".km_accepted_terms").prop('checked', true);
                } else {
                    $(".km_accepted_terms").prop('checked', false);
                }
            });
            $(document).on('click', '.open_km_modal', function () {
                var modalId = $(this).data('target');
                var kidId = $(this).data('kid-id');
                $(modalId).find('input, select, textarea').each(function () {
                    $(this).attr('data-kid-id', kidId);
                });
                $(modalId).fadeIn();
            });
            $(document).on('click change blur keyup', '.km_kids_form_modal input, .km_kids_form_modal select, .km_kids_form_modal textarea', function () {
                var kidId = $(this).data('kid-id');
                $("#update_kid_info_" + kidId).val('true');
            });
            $(document).on('click', '.km_popup_close', function (e) {
                e.preventDefault();
                var modalId = $(this).data('popup-id');
                $(modalId).fadeOut();
            });
            $(document).on('click', '.save_medical_forms', function (e) {
                e.preventDefault();
                var formvalid = false;
                var formtype = $(this).data('form-type');
                var kidId = $(this).data('kid-id');
                var wraperId = formtype + '_' + kidId;
                /* forms with input fields */
                if (formtype == 'kidsDoctors' || formtype == 'kidsMedicalInsurances' || formtype == 'kidsDentalInsurances') {
                    $('#km_purchase_form').parsley($this.settings.parsley_valiation_options).whenValidate({
                        group: wraperId
                    }).done(function () {
                        formvalid = true;
                    });
                } else if (formtype == 'kidsHealthConcerns' || formtype == 'kidsMedicationAllergies' || formtype == 'kidsEnvironmentAllergies' || formtype == 'kidsSymptoms' || formtype == 'kidsTreatments' || formtype == 'kidsDietRestricts' || formtype == 'kidsFoodAllergies') {
                    var totalcheckbox = $('#' + wraperId).find('input[type="checkbox"]').length;
                    var checkedcheckbox = $('#' + wraperId).find('input[type="checkbox"]:checked').length;
                    if (totalcheckbox > checkedcheckbox && checkedcheckbox > 0) {
                        formvalid = true;
                    }


                }

                if (formvalid) {
                    $(this).parents('.km_modal').fadeOut();
                    $(this).parents('.km_modal').find('.med_form_error').hide();
                    //console.log($(this).data('kid-id'));
                    //console.log('[data-target="#km_modal_' + formtype + '_' + kidId + '"]');
                    var targetlen = $('[data-target="#km_modal_' + formtype + '_' + kidId + '"]').length;
                    //console.log(targetlen);

                    $('[data-target="#km_modal_' + formtype + '_' + kidId + '"]').removeClass('Form_Error').addClass('Form_Success');




                } else {

                    $('[data-target="#km_modal_' + formtype + '_' + kidId + '"]').removeClass('Form_Success').addClass('Form_Error');
                    var errordiv = $(this).parents('.km_modal').find('.med_form_error');
                    errordiv.fadeIn();
                    setTimeout(function () {
                        errordiv.fadeOut();
                    }, 3000);

                }
            });
            $(document).on('change', '.km_noform', function () {
                if ($(this).is(':checked')) {
                    $(this).parents('.km_modal_medfor_wrap').find('.km_hidden_noform_field').val(true);
                    $(this).parents('.km_medical_form_wrap').find('input[type="checkbox"]:not(.km_noform)').prop({
                        'checked': false,
                        'disabled': false
                    });
                    $(this).parents('.km_medical_form_wrap').find('.km_checkbox_wrap:not(.km_noform_wrap)').addClass('disabled');
                    $(this).parents('.km_medical_form_wrap').find('.related_checkbox_fields .km_input').val('');
                    $(this).parents('.km_medical_form_wrap').find('.related_checkbox_fields').addClass('km_hidden');
                } else {
                    $(this).parents('.km_modal_medfor_wrap').find('.km_hidden_noform_field').val(false);
                    $(this).parents('.km_medical_form_wrap').find('input[type="checkbox"]:not(.km_noform)').prop('disabled', false);
                    $(this).parents('.km_medical_form_wrap').find('.km_checkbox_wrap:not(.km_noform_wrap)').removeClass('disabled');

                }
            });

            $(document).on('change', '.kid-form-checkbox', function (e) {
                if ($(this).prop('checked') == true) {
                    $(this).parents('.km_medical_form_wrap').find('.km_noform').prop({
                        'checked': false,
                        'disabled': false
                    });
                    $(this).parents('.km_medical_form_wrap').find('.km_checkbox_wrap:not(.km_noform_wrap)').removeClass('disabled');
                } else {

                    $(this).parents('.km_modal_medfor_wrap').find('.km_hidden_noform_field').val(true);
                    $(this).parents('.km_medical_form_wrap').find('input[type="checkbox"]:not(.km_noform)').prop('disabled', false);
                    $(this).parents('.km_medical_form_wrap').find('.km_checkbox_wrap:not(.km_noform_wrap)').removeClass('disabled');
                }

            });


            $(document).on('change', '.km_enable_form', function () {
                if ($(this).is(':checked')) {
                    $(this).parents('.km_medical_form_wrap').find('.km_input:not(.optional)').prop({
                        'required': true,
                        'disabled': false
                    });
                } else {
                    $(this).parents('.km_medical_form_wrap').find('.km_input:not(.optional)').prop({
                        'required': false,
                        'disabled': true
                    }).val('');
                }
                $this.requiredfields();
            });

            $(document).on('click', '.apply_store_credit', function () {
                var CreditId = $(this).data('credit-id');
                $('#manualStoreCreditPaid, #storeCreditId, #applySiblingDiscount').remove();
                var manualcredit = $(".manual_store_credit_paid:checked").val();
                var manualCreditType = $(".manual_store_credit_paid:checked").data('credit-type');
                if (manualcredit && manualCreditType !== 'siblingDiscount') {
                    $('#km_purchase_form').prepend('<input type="hidden" name="manualStoreCreditPaid" id="manualStoreCreditPaid" value="' + manualcredit + '"/>');
                }
                if (CreditId && manualCreditType !== 'siblingDiscount') {
                    $('#km_purchase_form').prepend('<input type="hidden" name="storeCreditId" id="storeCreditId" value="' + CreditId + '"/>');
                }
                if (manualCreditType == 'siblingDiscount') {
                    $('#km_purchase_form').prepend('<input type="hidden" name="applySiblingDiscount" id="applySiblingDiscount" value="true"/>');
                }
                $this.UpdateCart();
                $this.closepopup();
                $this.NextStep();
            });

            $(document).on('click', '.decline_store_credit', function () {
                $('#manualStoreCreditPaid, #storeCreditId, #applySiblingDiscount').remove();
                $this.UpdateCart();
                $this.closepopup();
                $this.NextStep();
            });
        },
        kidspageevents: function () {
            $(document).on('click', '.km_add_kid_modal', function () {
                $this.makeCall(fieldday_ajax.ajax_url, {
                    action: 'km_add_new_kid'
                }, function (response) {
                    if (response.status == 'success') {
                        $this.displayModal(response, 'modal-large');
                        $this.requiredfields();
                        $this.fielddaySelect();
                    } else if (response.status == 'fail') {
                        $this.DisplayAlert('error', response.message);
                    }
                });
            });
            $(document).on('click', '.km_update_insurance', function (event) {
                var btn = $(this);
                event.preventDefault();
                $('#parent_insurance_form').parsley($this.settings.parsley_valiation_options).whenValidate({
                    group: 'parent_insurance_form'
                }).done(function () {
                    var formData = new FormData($('#parent_insurance_form')[0]);
                    //formData.set('action', 'km_update_insurance');
                    btn.prop('disabled', true);
                    $this.postFormData(fieldday_ajax.ajax_url + "?action=km_update_insurance", formData, function (response) {
                        if (response.status == 'success') {
                            $this.DisplayMessage(btn, 'success', response.message);
                        } else if (response.status == 'fail') {
                            $this.DisplayMessage(btn, 'error', response.message);
                        }
                        btn.prop('disabled', true);
                    });
                });
            });
            $(document).on('change', '.km_hasextra_form', function () {
                if ($(this).is(':checked')) {
                    $(this).parents('.km_field_wrap').find('.related_checkbox_fields').removeClass('km_hidden');
                } else {
                    $(this).parents('.km_field_wrap').find('.related_checkbox_fields').addClass('km_hidden');
                    $(this).parents('.km_field_wrap').find('.km_input').val("");
                }
            });
            $(document).on('click', '.km_add_kid_save', function (event) {
                event.preventDefault();
                $('#km_form_kid_add').parsley($this.settings.parsley_valiation_options).whenValidate({
                    group: 'new_kid_create'
                }).done(function () {
                    var isUpdated = $this.updateDate($('#km_form_kid_add'));
                    if (isUpdated) {
                        var formData = new FormData($('#km_form_kid_add')[0]);
                        //formData.set('action', 'km_save_kid');
                        $this.postFormData(fieldday_ajax.ajax_url + "?action=km_save_kid", formData, function (response) {
                            if (response.status == 'success') {
                                $this.closepopup();
                                $this.DisplayAlert('success', response.message);
                                $('.km_single_kid_main').append(response.html)
                            } else if (response.status == 'fail') {
                                $this.DisplayAlert('error', response.message);
                            }
                        });
                    }
                });
            });
            $(document).on('click', '.km_update_profile', function (event) {
                event.preventDefault();
                var btn = $(this);
                var id = btn.data('id');
                $('#km_kid_profile_update').parsley($this.settings.parsley_valiation_options).whenValidate({
                    group: 'update_kid'
                }).done(function () {
                    var isDobUpdated = $this.updateDate($('#km_kid_profile_update'));
                    if (isDobUpdated) {
                        var formData = new FormData($('#km_kid_profile_update')[0]);
                        //formData.set('action', 'km_update_kid_profile');
                        //formData.set('id', id);
                        $this.postFormData(fieldday_ajax.ajax_url + "?action=km_update_kid_profile", formData, function (response) {
                            if (response.status == 'success') {
                                $this.DisplayMessage(btn, 'success', response.message);
                            } else if (response.status == 'fail') {
                                $this.DisplayMessage(btn, 'success', response.message);
                            }
                        });
                    }
                });
            });

            $(document).on('click', '.km_delete_kid', function (event) {
                event.preventDefault();
                var isConfirmed = confirm(fieldday_ajax.delteConfirm);
                if (isConfirmed) {
                    var kidId = $(this).data('kid-num-id');
                    $this.makeCall(fieldday_ajax.ajax_url, {
                        action: 'km_delete_kid',
                        kidId: kidId
                    }, function (response) {
                        if (response.status == 'success') {
                            $("#km_parent_kid_" + kidId).remove();
                            $this.DisplayAlert('success', response.message);
                        } else {
                            $this.DisplayAlert('error', response.message);
                        }
                    });
                }
            });

            $(document).on('click', '.km_save_kidform', function (event) {
                event.preventDefault();
                var btn = $(this);
                var form = $('#km_profile_kids_form');
                form.parsley($this.settings.parsley_valiation_options).whenValidate({
                    group: 'kids_forms_field'
                }).done(function () {
                    var formData = new FormData(form[0]);
                    //formData.set('action', 'km_save_kidforms');
                    $this.postFormData(fieldday_ajax.ajax_url + "?action=km_save_kidforms", formData, function (response) {
                        if (response.status == 'success') {
                            $this.DisplayMessage(btn, 'success', response.message);
                        } else {
                            $this.DisplayMessage(btn, 'error', response.message);
                        }
                    });
                });
            });
        },
        calculateCartPrice: function () {

        },
        getParticipants: function (cartKey) {
            $this.makeCall(fieldday_ajax.ajax_url, {
                action: 'km_atc_partcipants',
                cartkey: cartKey
            }, function (response) {
                if (response.status == 'success') {
                    $('.km_atc_participants').html(response.content);
                } else {
                    $this.DisplayAlert('error', response.message);
                }
            });
        },
        atc_cart_steps: function () {
            $(document).mouseup(function (e) {
                var container = $("#km_cart_items_wrap");
                // if the target of the click isn't the container nor a descendant of the container
                if (!$(e.target).parents('div').hasClass('km_cart_toggle') && !container.is(e.target) && container.has(e.target).length === 0) {
                    container.css({right: '-300px'});

                    jQuery('button.mobile_bttn').css({display: 'block'});
                }
            });
            $(document).on('click', '.km_edit_cart_item', function () {
                let cartkey = $(this).data('cart-key');

                $this.makeCall(fieldday_ajax.ajax_url, {
                    action: 'km_edit_cart_item',
                    cartkey: cartkey
                }, function (response) {
                    if (response.status == 'success') {
                        $this.displayModal(response, 'km-modal-medium km_addtocart_modal');
                        $('.km_modal_heading').hide();
                        //AtcsessionId = sessionId;
                        //AtctagId = tagId;
                        //AtcsessionDate = sessionDate;
                        $this.requiredfields();
                        $this.cartOnScroll();
                    } else {
                        $this.DisplayAlert('error', response.message);
                    }
                });
            });
            $(document).on('click', '.km_guest_participants li', function () {
                $('.km_guest_participants li').removeClass('km_active_participant');
                $(this).addClass('km_active_participant');
                let seatCount = $(this).data('count');
                $('#km_atc_participant_count').val(seatCount);
                /* display kid selection form*/
                var formData = new FormData($('#km_add_to_cart_form')[0]);
                //formData.set('action', 'km_get_kid_form'); // not working in i.e 11
                $this.postFormData(fieldday_ajax.ajax_url + "?action=km_get_kid_form", formData, function (response) {
                    $('.km_guestparticipant_forms').html(response.content);
                    $this.requiredfields();
                    $this.fielddaySelect();
                    if (seatCount == 1) {
                        $('.km_delete_participant').addClass('disabled');
                    } else {
                        $('.km_delete_participant').removeClass('disabled');
                    }
                });
            });
            $(document).on('click', '.add_new_participant', function (e) {
                e.preventDefault();
                $this.makeCall(fieldday_ajax.ajax_url, {
                    action: 'km_add_new_kid'
                }, function (response) {
                    $('.km_newparticipant_form').html(response.content);
                    $this.requiredfields();
                    $('.km_atc_participants, .km_atc_extended_care, .km_add_to_cart, .km_update_cart').hide();
                    $('.km_add_participant, .km_add_participant_cancel').removeClass('km_hidden');
                    $this.fielddaySelect();
                    $this.requiredfields();
                });
            });
            $(document).on('click', '.km_add_participant', function (e) {
                event.preventDefault();
                let cartKey = $('#km_atc_cartkey').val();
                $('#km_add_to_cart_form').parsley($this.settings.parsley_valiation_options).whenValidate({
                    group: 'new_kid_create'
                }).done(function () {
                    var isUpdated = $this.updateDate($('#km_add_to_cart_form'));
                    if (isUpdated) {
                        var formData = new FormData($('#km_add_to_cart_form')[0]);
                        //formData.set('action', 'km_save_kid');
                        $this.postFormData(fieldday_ajax.ajax_url + "?action=km_save_kid", formData, function (response) {
                            if (response.status == 'success') {
                                $('.km_newparticipant_form').html('');
                                $('.km_atc_participants, .km_atc_extended_care, .km_add_to_cart, .km_update_cart').show();
                                $('.km_add_participant, .km_add_participant_cancel').addClass('km_hidden');
                                $this.getParticipants(cartKey);
                            } else if (response.status == 'fail') {
                                $this.DisplayAlert('error', response.message);
                            }
                        });
                    }
                });
            });
            $(document).on('click', '.km_add_participant_cancel', function (e) {
                e.preventDefault();
                $('.km_newparticipant_form').html('');
                $('.km_atc_participants, .km_atc_extended_care, .km_add_to_cart, .km_update_cart').show();
                $('.km_add_participant, .km_add_participant_cancel').addClass('km_hidden');
            });
            $(document).on('click', '.km_profile_participants li:not(.add_new_participant)', function () {
                if ($(this).find('.selected_kid').prop("checked")) {
                    $(this).removeClass('km_active_participant');
                    $(this).find('.km_profile_participant_form input').attr("readonly", true);
                    $(this).find('.km_profile_participant_form input').attr("disabled", true);
                    $(this).find('.selected_kid').prop('checked', false);
                } else {
                    $(this).addClass('km_active_participant');
                    $(this).find('.selected_kid').prop('checked', true);
                    $(this).find('.km_profile_participant_form input').attr("readonly", false);
                    $(this).find('.km_profile_participant_form input').attr("disabled", false);
                }
                $('#km_atc_participant_count').val($('.km_active_participant').length);
            });


            $(document).on('click', '.km_update_cart', function (e) {
                e.preventDefault();
                $('#km_add_to_cart_form').parsley($this.settings.parsley_valiation_options).whenValidate({
                    group: 'atc_field'
                }).done(function () {
                    var linkaddress = $(this).attr('href');
                    let isupdated = $this.updateDate($('#km_add_to_cart_form'));
                    if (isupdated) {
                        $this.addSessionToCart(linkaddress);
                    }
                });
            });
            $(document).on('click', '.km_delete_participant', function () {
                let participantCount = $("#km_atc_participant_count").val();
                if (participantCount > 1) {
                    $(this).parents('.km_single_kid_wrap').remove();
                    let newparticipantcount = participantCount - 1;
                    if (newparticipantcount == 1) {
                        $('.km_delete_participant').addClass('disabled');
                    } else {
                        $('.km_delete_participant').removeClass('disabled');
                    }
                    $("#km_atc_participant_count").val(newparticipantcount);
                    $(".km_guest_participants li").removeClass('km_active_participant');
                    $(".km_guest_participants li[data-count='" + newparticipantcount + "']").addClass('km_active_participant');
                    let index = 1;
                    $('.km_single_kid_wrap').each(function () {
                        let participantText = $(this).data('participant-text');

                        $(this).find('.km_kidform_header h3').html(participantText + " " + index);
                        index++;
                    })
                }
            });
            $(document).on('click', '.km_add_to_cart', function (e) {
               var checkoutRediect= $(this).data('checkout-rediect');
               //return false;
                e.preventDefault();
                $('#km_add_to_cart_form').parsley($this.settings.parsley_valiation_options).whenValidate({
                    group: 'atc_field'
                }).done(function () {
                    var linkaddress = $(this).attr('href');
                    let isupdated = $this.updateDate($('#km_add_to_cart_form'));
                    if (isupdated &&  checkoutRediect !='undefined') {
                        $this.addSessionToCart(linkaddress,checkoutRediect);
                    }
                });
            });

            /*membership add to cart start */
            $(document).on('click', '.km_add_to_cart_membership', function (e) {
                e.preventDefault();
                var membershipid = $(this).data('membershipid');
                var membershipprice = $(this).data('membership-price');
                var providerId = $(this).data('providerid');
                var membershipTitle = $(this).data('membership-title');

                var formData = {
                    'membershipid': membershipid,
                    'membershipprice': membershipprice,
                    'providerId': providerId,
                    'title': membershipTitle,
                    'action': 'km_set_membershipcartitems'
                };
                $this.makeCall(fieldday_ajax.ajax_url, formData, function (response) {
                    if (response.status == 'success') {

                        $this.displayModal(response, 'modal-normal');
                        $this.CardInput();
                    }
                });


            });

            $(document).on('click', '.membership_purchase_button', function (e) {
                e.preventDefault();
                var membershipid = $(this).data('membershipid');
                var paymentmethod = $(this).data('paymentmethod');
                var purchasecount = $(this).data('purchasecount');
                var stripeToken;
                var savecard = $('.savecardcheck:checked').val();
                var cardinfo = {};
                cardinfo.number = $('#km_card_number').val();
                cardinfo.cvc = $('#km_card_cvc').val();
                cardinfo.exp_month = $('#expireMM').val();
                cardinfo.exp_year = $('.km_card_expiry_year').val();


                /* create stripe token*/
                $this.km_loader();
                Stripe.card.createToken(cardinfo, function (status, response) {
                    $this.makeCall(fieldday_ajax.ajax_url + "?action=km_process_stripe", {
                        token: response.id
                    }, function () {
                        if (response.error) {
                            $this.DisplayAlert('error', response.error.message);
                        } else {
                            setTimeout(function () {
                                stripeToken = response.id;
                                var formData = {
                                    'membershipid': membershipid,
                                    'paymentmethod': paymentmethod,
                                    'purchasecount': purchasecount,
                                    'stripeToken': stripeToken,
                                    'saveCard': savecard,
                                    'action': 'km_set_membershipurchase'
                                };
                                $this.km_loader();
                                $this.makeCall(fieldday_ajax.ajax_url, formData, function (response) {
                                    if (response.status == 'success') {
                                        $this.DisplayAlert('success', response.message);
                                        if(window.location.hostname == 'localhost' ){
                                            window.location = window.location.origin + "/fieldday/my-account/";
                                        }else{
                                            window.location = window.location.origin + "/my-account/";
                                        }

                                    }
                                });
                            }, 500);
                        }
                    });

                });



            });

            /*membership add to cart end */

           /*giftCard add to cart start */
           $(document).on('click', '.km_add_to_cart_giftCard', function (e) {
               e.preventDefault();
               var recipientName = $("[name='recipientname']").val();
               var recipientEmail =$("[name='recipient_email']").val();
               var max = parseInt($('input#km_gift_custom_amount').attr('max'));
               var min = parseInt($('input#km_gift_custom_amount').attr('min'));
               var price = parseInt($('input#km_gift_custom_amount').val());

               if(recipientName != ''){

                if( price > max){
                   $this.DisplayAlert('error', 'Amount is over the $2000 maximum');
                   return false;
                 }
               var giftCardid= $('.km_single_giftcard .km_gift_image').data('giftcardid');
               var giftCardImageorg= $('.km_single_giftcard .km_gift_image').attr('data-original');
               var giftCardImagethumb= $('.km_single_giftcard .km_gift_image').attr('src');
               var giftCardPrice= $('.giftcardprice').text();
               var title= $('.km_giftcard_title_single').text();
               var sendMethod= $('span.km_sendoption_value.selectedCartItem').text();
               var recipientName = $("[name='recipientname']").val();
               var recipientEmail =$("[name='recipient_email']").val();
               var recipientPhone =$("[name='recipient_phone']").val();
               var usergiftMsg = $("[name='usergiftmsg']").val();
               var senderName = $("[name='sender_name']").val();
               var sendDate = $("[name='send_date']").val();
               var giftCardPrice= $('.giftcardprice').text();

             }else{
               //console.log('fdgfd');
              // $("[name='recipientname'],[name='recipient_email']").css('border','1px solid red');
                $this.DisplayAlert('error', 'Fill the requried fields.');
               return false;
             }
               var formData = {
                   'giftCardid': giftCardid,
                   'image': giftCardImageorg,
                   'imagethumb': giftCardImagethumb,
                   'amount': giftCardPrice,
                   'title': title.trim(),
                   'sendmethod': sendMethod,
                   'recipientname': recipientName,
                   'recipientemail': recipientEmail,
                   'recipientphone': recipientPhone,
                   'usergiftmsg': usergiftMsg,
                   'sendername': senderName,
                   'senddate': sendDate,
                   'action': 'km_set_giftCardmodel'
               };
               $this.makeCall(fieldday_ajax.ajax_url, formData, function (response) {
                   if (response.status == 'success') {
                       $this.displayModal(response, 'modal-large');
                       $this.CardInput();
                   }
               });


           });


           $(document).on('click', '.giftcard_purchase_button', function (e) {
               e.preventDefault();

               var giftCardid = $(this).attr('data-giftcardid');
               var paymentmethod = $(this).data('paymentmethod');
               var purchasecount = $(this).data('purchasecount');
               var giftCardImage = $('.km_gift_image').text();
               var giftCardImagethumb = $('.km_gift_imagethumb').text();
               var senderDisplayName = $('.sendername').text();
               var amount = $('.km_gift_amount ').text();
               var userName;
               var userEmail;
               var userPhone;
               userName = $('.km_gift_loginusername').text();
               senderName = $('.km_gift_username').text();
               senderEmail = $('.km_gift_useremail').text();
               senderPhone = $("[name='recipient_phone']").val();
               massgage = $("span.km_gift_msg.purchase_model p").text();
               userEmail = $("[name='parent[email]']").val();
               userPhone = $("[name='parent[phone]']").val();
               guest = $("input#usreguest").val();
               if(userEmail == undefined && userPhone == undefined){
                  userName = $("[name='userDetails[name]']").val();
                  userEmail = $("[name='userDetails[email]']").val();
                  userPhone = $("input#parent_phone").val();
               }
               var stripeToken;
               var savecard = $('.savecardcheck:checked').val();
               var cardinfo = {};
               cardinfo.number = $('#km_card_number').val();
               cardinfo.cvc = $('#km_card_cvc').val();
               cardinfo.exp_month = $('#expireMM').val();
               cardinfo.exp_year = $('.km_card_expiry_year').val();


               /* create stripe token*/
               $this.km_loader();
               Stripe.card.createToken(cardinfo, function (status, response) {
                   $this.makeCall(fieldday_ajax.ajax_url + "?action=km_process_stripe", {
                       token: response.id
                   }, function () {
                       if (response.error) {
                           $this.DisplayAlert('error', response.error.message);
                       } else {
                           setTimeout(function () {
                               stripeToken = response.id;
                               var formData = {
                                   'giftCardid': giftCardid,
                                   'paymentmethod': paymentmethod,
                                   'purchasecount': purchasecount,
                                   'giftCardImage': giftCardImage,
                                   'giftCardImagethumb': giftCardImagethumb,
                                   'userName': userName,
                                   'userEmail': userEmail,
                                   'userPhone': userPhone,
                                   'amount': amount,
                                   'massgage': massgage,
                                   'stripeToken': stripeToken,
                                   'saveCard': savecard,
                                   'sendername': senderName,
                                   'senderemail': senderEmail,
                                   'senderphone': senderPhone,
                                   'senderDisplayName': senderDisplayName,
                                   'guest': guest,
                                   'action': 'km_set_giftcardPurchase'
                               };
                               $this.km_loader();
                               console
                               $this.makeCall(fieldday_ajax.ajax_url, formData, function (response) {
                                   if (response.status == 'success') {
                                       $this.DisplayAlert('success', response.message);
                                       if(window.location.hostname == 'localhost' ){
                                           window.location = window.location.origin + "/fieldday/my-account/";
                                       }else{
                                           window.location = window.location.origin + "/my-account/";
                                       }
                                   }
                               });
                           }, 500);
                       }
                   });

               });



           });
            /*giftCard add to cart end */

            /*giftcard single popupshow start*/

            $(document).on('click', '#km_giftpurchase_btn', function (e) {
                e.preventDefault();
                var giftcardid = $(this).data('giftcardid');
                var giftcardtitle = $(this).data('title');
                var giftcardid = $(this).data('giftcardid');
                var giftcardpricerange = $(this).data('giftcardprice-range');
                var buttontext = $(this).text();

                  var formData = {
                      'giftcardid': giftcardid,
                      'giftcardtitle': giftcardtitle,
                      'giftcardpricerange': giftcardpricerange,
                      'buttontext': buttontext,
                      'action': 'km_set_singlegiftcard'
                  };
                  $this.makeCall(fieldday_ajax.ajax_url, formData, function (response) {
                      if (response.status == 'success') {
                          $this.displayModal(response, 'modal-large km_single_giftcardpopup');
                          $('.km_single_giftcard .km_single_giftdesign:first-child img').trigger('click');
                          var msg = $('#giftmsg').text();
                           $('#giftcardmsg').text(msg);
                            $('#giftmsg').keyup(function() {
                                var giftmsg = this.value;
                                $('#giftcardmsg').text(giftmsg);
                            });
                      }
                  });

              });


            /*giftcard single popupshow ends*/

            /*checkout payment Installment popupshow start*/

            $('body').on('click', 'p.km_installments_heading', function () {
                var formdata = {
                    action: 'km_set_checkoutpayments'
                };

                var sessionId = $(this).find('i#km_checkoutpayments').data('sessionid');
                if (sessionId) {
                    formdata.session_id = sessionId;
                }
                $this.makeCall(fieldday_ajax.ajax_url, formdata, function (response) {
                    $this.displayModal(response, 'modal-small km_payment_installment');
                });
            });

              /*checkout payment Installment popupshow end*/

            /*
             jQuery('body').on('click',function(e){
             e.preventDefault();
             jQuery('.typescontent').hide();
             });
             */

            /*$(document).on('change', 'input.selected_kid', function() {
             Â var limit = $('#km_atc_seat_amount').val();
             Â var check = $('.selected_kid:checked').length;
             Â if(check > limit) {
             Â this.checked = false;
             Â var confirmation = confirm(fieldday_ajax.confirm_pop_text);
             Â if(confirmation == true){
             Â $this.display_atc_prev_step();
             Â }
             Â }
             Â });*/
            $(document).on('click', '.atc_prev_step', function () {
                $this.display_atc_prev_step();
            });
            $(document).on('click', '.km_cart_toggle', function () {
                $this.updatefielddayCart();
            });
            /*-- mobile cart view code start --*/
            $(document).on('click', '.mobile_bttn', function () {
                $this.updatefielddayCartMobile();
            });
            /*-- mobile cart view code end --*/
            $(document).on('click', '.km_remove_cart_item', function () {
                $('#km_cart_items_wrap').addClass('fieldday_ajax_processing');
                $('#km_cart_items_wrap_mobile').addClass('fieldday_ajax_processing');
                var cartkey = $(this).data('cart-key');
                $this.makeCall(fieldday_ajax.ajax_url, {
                    action: 'km_remove_cart_item',
                    cart_key: cartkey
                }, function (data) {
                    if (data.status == 'success') {
                        $('#km_cart_items_wrap_mobile').html(data.content); /*-- mobile cart view code  --*/
                        $('#km_cart_items_wrap').html(data.content);
                        $('#km_cart_total_count').html(data.items);
                        $('.mobile_cart_count').html(data.items); /*-- mobile cart view code  --*/
                        $('#km_cart_items_wrap_mobile a.km_btn').after("<p class='continue_shopping_cart'><a href='/purchase/'>Continue Shopping</a></p>");/*-- mobile cart view code  --*/
                        $('#km_cart_items_wrap_mobile').removeClass('fieldday_ajax_processing');
                        $('#km_cart_items_wrap').removeClass('fieldday_ajax_processing');

                        var countitme = $('.mobile_cart_count').text();
                        if (countitme < 1) {
                            $('.cart_bttn_mobile').addClass('mobile_cart_count_0');
                        } else {
                            $('.cart_bttn_mobile').removeClass('mobile_cart_count_0');
                        }

                    } else {
                        $this.DisplayAlert('error', 'error to get the cart information');
                    }
                }, true);
            });



        },
        /*kidFormsinCart: function(){
         Â var formData = new FormData($('#km_add_to_cart_form')[0]);
         Â //formData.set('action', 'km_get_kid_form'); // not working in i.e 11
         Â $this.postFormData(fieldday_ajax.ajax_url+"?action=km_get_kid_form", formData, function (response) {
         Â $('.km_atc_kid_forms').html(response.content);
         Â $this.requiredfields();
         Â $this.fielddaySelect();
         Â });
         Â },*/
        cartOnScroll: function () {
            let displayheader = false;
            $('.km_addtocart_modal .km_modal_content').scroll(function () {
                if ($(this).scrollTop() < 50) {
                    displayheader = false;
                    $('.km_modal_heading').hide();
                    $('.km_atc_header').show();
                }
                if (displayheader && $this.inRange($(this).scrollTop(), 45, 55)) {
                    return;
                }
                if ($(this).scrollTop() > 50) {
                    displayheader = true;
                    $('.km_modal_heading').show();
                    $('.km_atc_header').hide();
                } else {
                    displayheader = false;
                    $('.km_modal_heading').hide();
                    $('.km_atc_header').show();
                }
            });
        },
        updateDate: function (form) {
            $('.custom_dob_error').remove();
            var error = false;
            form.find('.km_dob_wrap').each(function () {
                var year = $(this).find('.km_date_year').val();
                var month = $(this).find('.km_date_month').val();
                var day = $(this).find('.km_date_day').val();
                var datestring = year + "-" + month + "-" + day;
                var date = moment(datestring);
                var agefrom = $(this).data('age-from');
                var ageto = $(this).data('age-to');
                var age = moment().diff(datestring, 'years', false);
                if (!date.isBefore(moment(), 'day') || !date.isValid()) {
                    $(this).append("<span class='custom_dob_error'>Date is invalid</span>");
                    error = true;
                }
                if (age < agefrom || age > ageto) {
                    $(this).find('.custom_dob_error').remove();
                    $(this).append("<span class='custom_dob_error'>Age limit for this activity is " + agefrom + "y - " + ageto + "y.</span>");
                    error = true;
                }
                $(this).find('.km_hidden_dob').val(datestring);
            });

            if (error) {
                return false;
            } else {
                return true;
            }
        },
        addSessionToCart: function (linkaddress,checkoutRediect) {
            var formData = new FormData($('#km_add_to_cart_form')[0]);
            formData.append('checkoutRediect', checkoutRediect);
            //formData.set('action', 'km_set_cartitems');
            $this.postFormData(fieldday_ajax.ajax_url + "?action=km_set_cartitems", formData, function (response) {
                console.log(response);
                if (response.status == 'success') {
                    //$this.closepopup();
                    var isMobile = /iPhone|iPad|iPod|Android/i.test(navigator.userAgent);
                    if (isMobile) {
                        $this.updatefielddayCartMobile();
                        $('.cart_bttn_mobile').removeClass('mobile_cart_count_0');
                    } else {
                        $this.updatefielddayCart();
                    }
                    var timer;
                    window.clearTimeout(timer);
                    timer = setTimeout(function () {
                        $("#km_cart_items_wrap").css("right", "-300px");
                    }, 5000);

                    if (response.pageredirect) {
                        window.location.href = response.pageredirect + '?cart=true';
                    }

                    if (linkaddress) {
                        window.location.href = linkaddress;
                    } else {
                        $this.closepopup();
                    }
                } else {
                    $this.DisplayAlert('error', response.message);
                }
            });
        },
        updatefielddayCart: function () {
            $('#km_cart_items_wrap').css({right: '0px'}).html('').addClass('fieldday_ajax_processing');
            $this.makeCall(fieldday_ajax.ajax_url, {
                action: 'get_cart_data'
            }, function (data) {
                if (data.status == 'success') {
                    $('#km_cart_items_wrap').html(data.content);
                    $('#km_cart_total_count').html(data.items);

                } else {
                    $this.DisplayAlert('error', 'error to get the cart information');
                }
                $('#km_cart_items_wrap').removeClass('fieldday_ajax_processing');

                if (data.items > 3) {
                    $('#km_cart_items_wrap ul').css('height', "550px");
                } else {
                    $('#km_cart_items_wrap ul').css('height', "auto");

                }
            }, true);
        },
        /*-- mobile cart view code start --*/
        updatefielddayCartMobile: function () {
            $('#km_cart_items_wrap_mobile').css({top: '0px'}).html('').addClass('fieldday_ajax_processing');

            $this.makeCall(fieldday_ajax.ajax_url, {
                action: 'get_cart_data'
            }, function (data) {
                if (data.status == 'success') {
                    $('#km_cart_items_wrap_mobile').html(data.content);
                    $('.mobile_cart_count').html(data.items);
                    $('.cart_bttn_mobile').removeClass('mobile_cart_count_0');
                    $('#km_cart_items_wrap').html(data.content);
                    $('#km_cart_total_count').html(data.items);

                } else {
                    $this.DisplayAlert('error', 'error to get the cart information');
                }
                $('#km_cart_items_wrap_mobile').removeClass('fieldday_ajax_processing');
                $('button.mobile_bttn').css({display: 'none'});
                $('#km_cart_items_wrap_mobile a.km_btn').after("<p class='continue_shopping_cart'><a href='/purchase/'>Continue Shopping</a></p>");

                if (data.items > 3) {
                    $('#km_cart_items_wrap_mobile ul').css('height', "550px");
                } else {
                    $('#km_cart_items_wrap_mobile ul').css('height', "auto");
                }
            }, true);
        },
        /*-- mobile cart view code end --*/
        saveKidsIntoLocal: function () {
            var savedKids = JSON.parse($this.getCookie('km_saved_kids'));
            if (!savedKids) {
                savedKids = {};
            }
            var formData = $('#km_add_to_cart_form').serializeJSON();
            var kidsData = formData.ATC.kids;
            $.each(kidsData, function (index, Kid) {
                var schoolId = Kid.school;
                Kid.school = {};
                Kid.school._id = schoolId;
                savedKids[Kid._id] = Kid;
            });
            $this.setCookie('km_saved_kids', JSON.stringify(savedKids));
        },
        setCookie: function (name, value, days) {
            var expires = "";
            if (days) {
                var date = new Date();
                date.setTime(date.getTime() + (days * 24 * 60 * 60 * 1000));
                expires = "; expires=" + date.toUTCString();
            }
            document.cookie = name + "=" + (value || "") + expires + "; path=/";
        },
        getTimezoneOffset: function () {
            function z(n) {
                return (n < 10 ? '0' : '') + n
            }
            var offset = new Date().getTimezoneOffset();
            var sign = offset < 0 ? '' : '-';
            offset = Math.abs(offset);
            var offsetvalue = sign + z(offset / 60 | 0) + z(offset % 60);
            if (offsetvalue) {
                $this.setCookie('offset', offsetvalue);
            }
        },
        getCookie: function (name) {
            var nameEQ = name + "=";
            var ca = document.cookie.split(';');
            for (var i = 0; i < ca.length; i++) {
                var c = ca[i];
                while (c.charAt(0) == ' ')
                    c = c.substring(1, c.length);
                if (c.indexOf(nameEQ) == 0)
                    return c.substring(nameEQ.length, c.length);
            }
            return null;
        },
        /*display_atc_next_step: function () {
         Â if ($atcstep <= $maxstepnumber) {
         Â $atcstep++;
         Â $this._display_step();
         Â }

         Â },*/
        /*_display_step: function () {
         Â if ($atcstep >= $minstepnumber && $atcstep <= $maxstepnumber) {
         Â $('.atc_next_step').html(fieldday_ajax.atc_next_btn).show();
         Â $('.atc_prev_step').html(fieldday_ajax.atc_prev_btn).show();

         Â if ($atcstep == $minstepnumber) {
         Â $('.atc_prev_step').hide();
         Â }

         Â if ($atcstep == $maxstepnumber) {
         Â //$('.atc_next_step').html(fieldday_ajax.add_to_cart_btn);
         Â //$('.km_modal_footer').hide();
         Â $('.km_atc_laststep_btn').removeClass('km_hidden');
         Â $('.atc_next_step').hide();
         Â $('.atc_prev_step').text('Back');
         Â }else {
         Â //$('.km_modal_footer').show();
         Â $('.km_atc_laststep_btn').addClass('km_hidden');
         Â }
         Â $('.add_to_cart_step').hide();
         Â $('#add_to_cart_step_' + $atcstep).show();
         Â var steptitle = $('#add_to_cart_step_' + $atcstep).data('step-title');
         Â $('.km_modal_heading').html(steptitle);
         Â $("#modal-large").removeClass('modal-large');
         Â var modalCllass = $('#add_to_cart_step_' + $atcstep).data('modal-class');
         Â $('#km_modal').removeClass('modal-normal modal-large').addClass(modalCllass);
         Â }
         Â },*/
        /*display_atc_prev_step: function () {
         Â var parentKidsCount = $('.kids-pop-listing .kid-pop-single').length;
         Â if($atcstep == 3 && parentKidsCount == 0) {
         Â $atcstep--;
         Â }
         Â if ($atcstep >= $minstepnumber) {
         Â $atcstep--;
         Â $this._display_step();
         Â }

         Â },*/
        inRange: function (n, nStart, nEnd) {
            if (n >= nStart && n <= nEnd)
                return true;
            else
                return false;
        },
        registerSession: function (sessionId, tagId, sessionDate, sessionfeatured) {
            $this.makeCall(fieldday_ajax.ajax_url, {
                action: 'km_display_cartform',
                sessionId: sessionId,
                tagId: tagId,
                sessionDate: sessionDate,
                sessionfeatured: sessionfeatured
            }, function (response) {
                if (response.status == 'success') {
                    $this.displayModal(response, 'km-modal-medium km_addtocart_modal');
                    $('.km_modal_heading').hide();
                    AtcsessionId = sessionId;
                    AtctagId = tagId;
                    AtcsessionDate = sessionDate;
                    $this.requiredfields();
                    $this.cartOnScroll();
                } else {
                    $this.DisplayAlert('error', response.message);
                }
            });
        },
        merchandiseevents: function () {
            $(document).on('change', '.km_merchandise', function () {
                if ($(this).is(':checked')) {
                    $('.km_session_type').prop('checked', false);
                    var layout = $('#layoutdesign').val();
                    $this.makeCall(fieldday_ajax.ajax_url, {
                        action: 'km_get_bankdays',
                        data: layout
                    }, function (response) {
                        if (response.status == 'success') {
                            $('.km_provider_sessions').hide();
                            $('.km_provider_merchandise').html(response.content).show();
                            /*var newUrl = $this.addQueryVar(location.href, 'merchandise', true);
                             Â history.pushState({}, null, newUrl);*/
                        } else if (response.status == 'fail') {
                            $this.DisplayAlert('error', response.message);
                        }
                    });
                } else {
                    //var tagId = $('.filter_type:checked').val();
                    //filter_posts(tagId);
                }
            });
            $(document).on('click', '.purchase_merchandise', function () {
                $('#fieldday_merchandise_form').parsley($this.settings.parsley_valiation_options).whenValidate({
                    group: 'merchandise_field'
                }).done(function () {
                    $this.StripeProcess($('#fieldday_merchandise_form'), function (response) {
                        if (response.error) {
                            $this.DisplayAlert('error', response.error.message);
                        } else {
                            $("#fieldday_merchandise_form .merchandise_stripeToken").val(response.id);
                            var formData = new FormData($('#fieldday_merchandise_form')[0]);
                            //formData.set('stripeToken', response.id);
                            //formData.set('action', 'km_merchandise_process');
                            //formData.set('paymentMethod', 'card');
                            $this.postFormData(fieldday_ajax.ajax_url + "?action=km_merchandise_process", formData, function (response) {
                                if (response.status == 'success') {
                                    $this.displayModal(response);
                                } else {
                                    $this.DisplayAlert('error', response.message);
                                }
                            });
                        }

                    });
                });
            });
        },

        registerSessionTiming: function (button, event) {
            var formdata = {
                action: 'km_registerSessionTiming'
            };
            var sessionId = $(button).data('session-id');
            var sessionfeatured = $(button).data('session-featured');
            var offerId = $(button).data('offer-id');
            if (sessionId) {
                var tagId = $(button).data('tag-id');
                var sessionDate = $(button).data('session-date');
                formdata.session_id = sessionId;
                formdata.tagId = tagId;
                formdata.session_date = sessionDate;
                formdata.sessionfeatured = sessionfeatured;
                AtcsessionId = sessionId;
                AtctagId = tagId;
                AtcsessionDate = sessionDate;

            }

            if (offerId) {
                formdata.offerId = offerId;
                AtcOfferId = offerId;
            }

            $this.makeCall(fieldday_ajax.ajax_url, formdata, function (response) {
                $this.displayModal(response, 'modal-large');
                $this.fielddaySessionTime();
            });
        },
        hasCart: function () {
            //var path=window.location.origin;
            var rediectPage = document.URL.split('?')[1];
            if (rediectPage == 'cart=true') {
                $this.updatefielddayCart();
                setTimeout(function () {
                    $("#km_cart_items_wrap").css("right", "-300px");
                }, 5000);
            }
            $('body').on('click', '#sessiontimenext', function () {
                var sessionDate = [];
                var sessionid;
                var sessiontag;
                var sessionfeatured;
                jQuery(':checkbox:checked').each(function (i) {
                    sessionfullweek = jQuery(this).data('sessionfullweek');
                    if(sessionfullweek){
                     sessionDate='';
                   }else{
                    sessionDate.push(this.value);
                   }
                    sessionid = jQuery(this).data('session-id');
                    sessiontag = jQuery(this).data('session-tag');
                    sessionfeatured = jQuery(this).data('session-featured');
                });

                if(sessionid != undefined){
                    $this.registerSession(sessionid, sessiontag, sessionDate, sessionfeatured);
                }else{
                    $this.DisplayAlert('error', 'Please Select Date!');
                }

            });

        },
        countItmeCart: function () {
            var countitme = $('.mobile_cart_count').text();
            if (countitme < 1) {
                $('.cart_bttn_mobile').addClass('mobile_cart_count_0');
            } else {
                $('.cart_bttn_mobile').removeClass('mobile_cart_count_0');
            }
            if (countitme > 4) {
                $('#km_cart_items_wrap_mobile ul').css('height', "550px");
            } else {
                $('#km_cart_items_wrap_mobile ul').css('height', "auto");
            }
            var countitmedesktop = $('#km_cart_total_count').text();
            if (countitme > 4) {
                $('#km_cart_items_wrap ul').css('height', "550px");
            } else {
                $('#km_cart_items_wrap ul').css('height', "auto");
            }

        },
        registermerchandise: function (offerId) {
            $this.makeCall(fieldday_ajax.ajax_url, {
                action: 'km_merchandise_form',
                offerId: offerId
            }, function (response) {
                $this.displayModal(response, response.modalclass);
                AtcOfferId = offerId;
                $this.requiredfields();
                $this.PhoneInput();
                $this.CardInput();
            });
        },
        login: function (button, event) {
            event.preventDefault();
            $(button).parents('form').parsley($this.settings.parsley_valiation_options_register).whenValidate({
                group: 'km_login'
            }).done(function () {
                var formData = new FormData($('#km_login_form')[0]);
                $this.postFormData(fieldday_ajax.ajax_url, formData, function (response) {
                    if (response.isGuest) {
                        window.location.reload();
                    }else{

                    }
                    $this.afterLogin(response, button);
                });
            });
        },
        LoginWithFacebook: function () {
            var data = {
                action: 'km_social_login',
                AuthCode: $code,
                client: 'facebook',
            };
            $this.makeCall(fieldday_ajax.ajax_url, data, function (response) {
                $this.afterLogin(response);

            });
        },
        LoginWithGoogle: function () {

            var data = {
                action: 'km_social_login',
                AuthCode: $code,
                client: 'google'
            };
            $this.makeCall(fieldday_ajax.ajax_url, data, function (response) {
                $this.afterLogin(response);

            });
        },
        register: function (button, event) {
            event.preventDefault();
            $(button).parents('form').parsley($this.settings.parsley_valiation_options_register).whenValidate({
                group: 'register'
            }).done(function () {
                var formData = new FormData($('#km_register_form')[0]);
                $this.postFormData(fieldday_ajax.ajax_url, formData, function (response) {
                    $this.afterLogin(response, button);
                });
            });
        },
        updateParent: function (button, event) {
            event.preventDefault();
            if (!$(button).hasClass('disabled')) {
                $(button).parents('form').parsley($this.settings.parsley_valiation_options).whenValidate({
                    group: 'profile_fields'
                }).done(function () {
                    var formData = new FormData($('#profile_update')[0]);
                    //formData.set('action', 'km_update_profile');
                    $this.postFormData(fieldday_ajax.ajax_url + "?action=km_update_profile", formData, function (response) {
                        if (response.status == 'success') {
                            $this.DisplayMessage(button, 'success', response.message);
                        } else {
                            $this.DisplayMessage(button, 'error', response.message);
                        }
                    });
                });
            }
        },
        updatePassword: function (button, event) {
            event.preventDefault();
            if (!$(button).hasClass('disabled')) {
                var formData = new FormData($('#km_reset_password_form')[0]);
                //formData.set('action', 'km_update_password');
                $this.postFormData(fieldday_ajax.ajax_url + "?action=km_update_password", formData, function (response) {
                    if (response.status == 'success') {
                        $('#km_reset_password_form')[0].reset();
                        $this.DisplayMessage(button, 'success', response.message);
                    } else {
                        $this.DisplayMessage(button, 'error', response.message);
                    }
                });
            }
        },
        profileForm: function (button, event) {
            event.preventDefault();
            if (!$(button).hasClass('disabled')) {
                var id = $(button).attr('id');
                var dataId = $(button).data('id');
                var formData = {
                    'page': id,
                    'action': 'km_profile_tab',
                    dataId: dataId
                };
                $this.makeCall(fieldday_ajax.ajax_url, formData, function (response) {
                    if (response.status == 'success') {
                        $('.km_tab_data').html('');
                        $('.km_nav_link').removeClass('km_active')
                        $(button).addClass('km_active');
                        $('.km_tab_data').html(response.content);
                        $this.PhoneInput();
                        $this.requiredfields();
                        $this.fielddaySelect();
                        $this.fielddaySessionTime();
                    } else if (response.status == 'fail') {
                        $this.DisplayAlert('error', response.message);
                    }
                });
            }
        },
        creditStatementFilter: function (button, isPerdayCredit) {
            $('.km_credit_filter').removeClass('km_cred_filter_active');
            $(button).addClass('km_cred_filter_active');
            var formData = {
                'page': 'store_statement',
                'action': 'km_profile_tab',
                isPerdayCredit: isPerdayCredit
            };
            $this.makeCall(fieldday_ajax.ajax_url, formData, function (response) {
                if (response.status == 'success') {
                    $('.km_tab_data').html('');
                    $('.km_tab_data').html(response.content);
                    $('.km_credit_filter').removeClass('km_cred_filter_active');
                    if (isPerdayCredit == 'true') {
                        $('.km_day_credit').addClass('km_cred_filter_active');
                    } else if (isPerdayCredit == 'false') {
                        $('.km_dollar_credit').addClass('km_cred_filter_active');
                    }

                } else if (response.status == 'fail') {
                    $this.DisplayAlert('error', response.message);
                }
            });
        },
        ajaxPurchase: function (button, event) {
            event.preventDefault();
            if (!$(button).hasClass('disabled')) {
                $('.km_pagination li').removeClass('km_pagination_active');
                $(button).addClass('km_pagination_active');
                var pagenumber = $(button).data('page');
                var action = 'km_get_purchase';
                var formData = {
                    'pagenumber': pagenumber,
                    'action': 'km_get_purchase'
                };
                $this.makeCall(fieldday_ajax.ajax_url, formData, function (response) {
                    if (response.status == 'success') {
                        $('.km_tab_data').html('');
                        $('.km_tab_data').html(response.content);
                    } else if (response.status == 'fail') {
                        $this.DisplayAlert('error', response.message);
                    }
                });
            }
        },
        ajaxPagination: function (button, event) {
            event.preventDefault();
            if (!$(button).hasClass('disabled')) {
                $('.km_pagination li').removeClass('km_pagination_active');
                $(button).addClass('km_pagination_active');
                var pagenumber = $(button).data('page');
                var action = 'km_get_purchase';
                var formData = {
                    'pagenumber': pagenumber,
                    'action': 'km_get_pagination'
                };
                $this.makeCall(fieldday_ajax.ajax_url, formData, function (response) {
                    if (response.status == 'success') {
                        $('.km_pagination_data').html('');
                        $('.km_pagination_data').html(response.content);
                    } else if (response.status == 'fail') {
                        $this.DisplayAlert('error', response.message);
                    }
                });
            }
        },
        readURL: function (input) {
            if (input.files && input.files[0]) {
                var reader = new FileReader();

                reader.onload = function (e) {
                    $(input).parents('.profile-pic-upload').find('.preview-img')
                            .attr('src', e.target.result)
                            .show();
                    $(input).parents('.profile-pic-upload').find('.km_default_avatar').hide();
                };

                reader.readAsDataURL(input.files[0]);
            }
        },
        afterLogin: function (response, button) {

            var extraParam = null;
            if ($state) {
                extraParam = $state.split('_');
            } else {
                extraParam = [];
            }

            if (response.status == 'success') {

                if (extraParam[1]) {
                    AtcsessionId = extraParam[1];
                }
                if (extraParam[4]) {
                    AtcOfferId = extraParam[4];
                }
                if (button) {
                    $this.DisplayMessage(button, 'success', response.message);
                }
                if (AtcOfferId) {
                    $this.registermerchandise(AtcOfferId);
                    $isKmUser = true;
                    $this.updateMenu();
                } else if (AtcsessionId) {
                    if (extraParam[2]) {
                        AtctagId = extraParam[2];
                        $(".km_session_type[value=" + AtctagId + "]").prop('checked', true).trigger('change');
                    }
                    if (extraParam[3]) {
                        AtcsessionDate = extraParam[3];
                    }

                    $this.registerSession(AtcsessionId, AtctagId, AtcsessionDate, response.sessionfeatured);
                    $isKmUser = true;
                    $this.updateMenu();
                } else {
                    if (response.redirect) {
                        window.location = response.redirect;
                    }
                }

            } else if (response.status == 'varificationsent') {
                $this.displayModal(response,'km_addtocart_modal verification_popup');
                $this.OtpInput();
                $this.PhoneInput();
                //$this.closePhoneUpdate();
                $this.OTPTimer($otptimer, true);
            } else if (response.status == 'nophone') {
                $this.displayModal(response);
                $this.OtpInput();
                $this.PhoneInput();
                //$this.openPhoneUpdate();
            } else {
                if (button) {
                    $this.DisplayMessage(button, 'error', response.message);
                } else {
                    alert(response.message);
                }
            }

            try {
                if (widgetId) {
                    grecaptcha.reset(widgetId);
                } else {
                    grecaptcha.reset();
                }

            } catch (err) {
            }

        },
        updateMenu: function () {
            $this.makeCall(fieldday_ajax.ajax_url, {
                action: 'km_getmenu_data'
            }, function (response) {
                if (response.status == 'success') {
                    if (!$("#menu_item_km_userinfo").length) {
                        let menuId = $('#' + response.menuId);
                        if ($('#' + response.menuId).length == 0) {
                            menuId = $('#' + response.slug);
                        }

                        menuId.append(response.html);
                        $('body').append(response.afterLoginScript);
                    }
                }
            }, true);
        },
        verifyOtp: function (button, event) {
            event.preventDefault();
            var formData = new FormData($('#km_verification_form')[0]);
            $this.postFormData(fieldday_ajax.ajax_url + "?action=km_verify_otp", formData, function (response) {
                if (response.status == 'success') {
                    $this.DisplayMessage(button, 'success', response.message);
                    $this.afterLogin(response);
                } else {
                    $this.DisplayMessage(button, 'error', response.message);
                }
            });
        },
        OtpInput: function () {
            $(document).on('keyup', '.km_otp_number', function (event) {
                // check for hyphen
                $('.otp_number_error').text('');
                if (event.which == 8) {
                    $(this).prev('.km_otp_number').focus();
                } else {
                    if ($(this).val().length >= 1) {
                        event.preventDefault();
                        if ($(this).next('.km_otp_number')) {
                          if (/\D/g.test(this.value))
                           {
                             // Filter non-digits from input value.
                             this.value = this.value.replace(/\D/g, '');
                            $('.otp_number_error').text('Please enter all 4 digits');
                           }else{
                             $(this).next('.km_otp_number').focus();
                           }

                        } else {
                            $(this).blur();
                        }
                    }
                }
            });
        },
        updatePhone: function (button, event) {
            event.preventDefault();
            if (!$(button).hasClass('disabled')) {
                var formData = new FormData($('#km_newphone_form')[0]);
                //formData.set('action', 'km_update_phone');
                $(button).parents('form').parsley($this.settings.parsley_valiation_options).whenValidate({
                    group: 'newphone_update'
                }).done(function () {
                    $this.postFormData(fieldday_ajax.ajax_url + "?action=km_update_phone", formData, function (response) {
                        if (response.status == 'success') {
                            $this.displayModal(response);
                            $this.DisplayMessage(button, 'success', response.message);
                            $this.OTPTimer($otptimer, true);
                            $this.PhoneInput();
                            $this.closePhoneUpdate();
                        } else {
                            $this.DisplayMessage(button, 'error', response.message);
                        }
                    });
                });
            }
        },
        otpEvents: function () {
            $(document).on('change', '.km_verify_code_type', function (e) {
                var verificationType = $(this).val();
                $('.km_verifcatio_hl_txt').removeClass('km_hidden');
                $('.km_inline_message').hide();
                $this.OTPTimer(0, true);
                if (verificationType == 'sms') {
                    $this.resendOtp($(this), e);
                    $('.km_verification_via_email .km_verifcatio_hl_txt').addClass('km_hidden');
                } else if (verificationType == 'email') {
                    $this.resendOtp($(this), e);
                    $('.km_verification_via_sms .km_verifcatio_hl_txt').addClass('km_hidden');
                }

            });
        },
        resendOtp: function (button, event) {
            event.preventDefault();
            if (!$(button).hasClass('disabled')) {
                var formData = new FormData($('#km_verification_form')[0]);
                //formData.set('action', 'km_resend_otp');
                $this.postFormData(fieldday_ajax.ajax_url + "?action=km_resend_otp", formData, function (response) {
                    if (response.status == 'success') {
                        $this.DisplayMessage(button, 'success', response.message);
                        $this.OTPTimer($otptimer, true);
                        $this.PhoneInput();
                        $this.closePhoneUpdate();
                    } else {
                        $this.DisplayMessage(button, 'error', response.message);
                    }
                });
            }
        },
        OTPTimer: function (remaining, resettimer) {
            if (resettimer && $timer) {
                clearTimeout($timer);
            }
            var m = Math.floor(remaining / 60);
            var s = remaining % 60;

            m = m < 10 ? '0' + m : m;
            s = s < 10 ? '0' + s : s;
            //document.getElementById('timer').innerHTML = m + ':' + s;
            $('.km_verification_form .otp_timer').html(m + ':' + s).show();
            remaining -= 1;
            if (remaining >= 0 && $timerOn) {
                $timer = setTimeout(function () {
                    $('.km_verification_form .resend_otp').addClass('disabled');
                    $this.OTPTimer(remaining);
                }, 1000);
                return;
            }

            if (!$timerOn) {
                // Do validate stuff here
                return;
            }
            $('.km_verification_form .otp_timer').html('');
            $('.km_verification_form .resend_otp').removeClass('disabled');
        },
        openPhoneUpdate: function () {
            $('.km_otp_verification_wrap').hide();
            $('.km_updatephone_wrap').show();
        },
        closePhoneUpdate: function () {
            jQuery('.km_otp_number').val('');
            $('.km_otp_verification_wrap').show();
            $('.km_updatephone_wrap').hide();
        },
        PhoneInput: function () {
            $(".km_phone_field").each(function () {
                var objectid = $(this).attr('id');
                var inputphone = document.querySelector("#" + objectid);
                var country_phone_code = $("#" + objectid).parents('.km_field_wrap').find('.country_code').val();
                var country_code = 'us';
                if (country_phone_code) {
                    var usercountrycode = fieldday.settings.allCountries[country_phone_code];
                    if (typeof usercountrycode !== 'undefined') {
                        country_code = usercountrycode;
                    }
                }
                if (objectid) {
                    var iti = window.intlTelInput(inputphone, {
                        initialCountry: country_code,
                        placeholderNumberType: 'FIXED_LINE',
                    });
                    inputphone.addEventListener("countrychange", function (e) {
                        var dialCode = iti.getSelectedCountryData().dialCode;
                        country_code = iti.getSelectedCountryData().iso2;
                        $("#" + objectid).parents('.km_field_wrap').find('.country_code').val(dialCode);
                    });
                    inputphone.addEventListener("keyup", function (e) {
                        var phone = this.value.replace(/ /g, '');
                        $("#" + objectid).parents('.km_field_wrap').find('.phone_number').val(phone);
                    });
                }
                var iso2 = country_code.toUpperCase();
                new Cleave(inputphone, {
                    phone: true,
                    phoneRegionCode: iso2
                });
            });
        },
        CardInput: function () {
            $(".km_card_number").each(function () {
                var objectid = $(this).attr('id');
                var _this = $(this);
                var inputcard = document.querySelector("#" + objectid);
                if (objectid) {
                    new Cleave(inputcard, {
                        creditCard: true,
                        onCreditCardTypeChanged: function (type) {
                            _this.next().removeAttr('class');
                            _this.next().addClass("km_card_type " + type);
                            //document.querySelector("." + objectid).innerHTML = '<i class="fa fa-cc-' + type + ' fa-fw fa-2x active" aria-hidden="true"></i>';
                        }
                    });
                }

            });
        },
        ClearSessionFilters: function (formId) {
            $(window).bind("pageshow", function () {
                // update hidden input field
                if ($(formId).length) {
                    $(formId)[0].reset();
                }
            });
        },
        fielddaySessionTime: function () {
            if ($('.km_session_single_item').length) {
                $('.km_session_single_item').each(function () {
                    var dateFrom = $(this).attr('data-time-stamp-from'),
                            dateTo = $(this).attr('data-time-stamp-to'),
                            programMonth = $(this).find('.km_session_month'),
                            programYear = $(this).find('.km_session_year'),
                            programFullDate = $(this).find('.km_session_fulldate'),
                            programTime = $(this).find('.km_sess_time'),
                            //Month From
                            convertedMonthFrom = moment.utc(dateFrom).local().format('MMM DD'),
                            //Month To
                            convertedMonthTo = moment.utc(dateTo).local().format('MMM DD'),
                            //Year
                            convertedYear = moment.utc(dateTo).local().format('YYYY'),
                            //Time From
                            convertedTimeFrom = moment.utc(dateFrom).local().format('h:mm a'),
                            //Time To
                            convertedTimeTo = moment.utc(dateTo).local().format('h:mm a');
                    if (dateFrom && dateTo) {
                        $(programMonth).html(convertedMonthFrom + ' - ' + convertedMonthTo);
                        programFullDate.html(convertedMonthFrom + ', ' + convertedYear + ' - ' + convertedMonthTo + ', ' + convertedYear);
                        $(programYear).html(convertedYear);
                        $(programTime).html(convertedTimeFrom + ' - ' + convertedTimeTo);
                    }
                });
            }
        },
        InitSessionFilter: function () {

        },
        process_personal_info: function (button, event) {
            event.preventDefault();
            var form = $(button).parents('form');
            $totalkids = form.find('.km_parent_kids').val();
            var group = $(button).data('group');
            $(button).parents('form').parsley($this.settings.parsley_valiation_options).whenValidate({
                group: group
            }).done(function () {
                $this.NextStep();
                if ($('.single_kid_info').length) {
                    $('.km_participant_form_text').removeClass('km_hidden');
                    $('.km_participant_form_notrequired_text').addClass('km_hidden');
                } else {
                    $('.km_participant_form_notrequired_text').removeClass('km_hidden');
                    $('.km_participant_form_text').addClass('km_hidden');
                }
                var formData = new FormData($('#km_purchase_form')[0]);
                $this.postFormData(fieldday_ajax.ajax_url + "?action=km_parent_info", formData, function (response) {
                    //console.log(response);

                    /*$('.open_km_modal').each(function(){
                     var  doctorFromId=$(this).attr('data-kid-id');
                     //console.log('doctorFromId',doctorFromId);
                     var searchInput = 'doctorStreet'+doctorFromId;
                     var autocomplete;
                     autocomplete = new google.maps.places.Autocomplete((document.getElementById(searchInput)), {
                     types: ['geocode']

                     });

                     google.maps.event.addListener(autocomplete, 'place_changed', function () {
                     var near_place = autocomplete.getPlace();
                     });

                     });*/

                }, true);
            });
        },
        process_kid_info: function (button, event) {
            event.preventDefault();
            var group = $(button).data('group');
            $(button).parents('form').parsley($this.settings.parsley_valiation_options).whenValidate({
                group: group
            }).done(function () {
                var incompleteForms = $('.fieldday_form_button.Form_Error').length;
                $('#storeCreditId').remove();
                if (incompleteForms == 0) {
                    /* check store credits */
                    if ($isKmUser) {
                        $this.checkStoreCredit(function (response) {
                            /* if has store credit */
                            if (response.status == 'success') {
                                $this.displayModal(response);
                            } else {
                                $this.UpdateCart();
                                $this.NextStep();
                            }
                        });
                    } else {
                        $this.UpdateCart();
                        $this.NextStep();
                    }
                } else {
                    $this.DisplayAlert('error', fieldday_ajax.invalid_form_message)
                }
            });
        },
        checkStoreCredit: function (callback) {
            $('#manualStoreCreditPaid, #storeCreditId, #applySiblingDiscount').remove();
            var formData = new FormData($('#km_purchase_form')[0]);
            $this.postFormData(fieldday_ajax.ajax_url + "?action=km_check_store_credit", formData, function (response) {
                callback(response);
            });
        },
        process_purchase: function (button, event) {
            event.preventDefault();
            var group = $(button).data('group');
            $(button).parents('form').parsley($this.settings.parsley_valiation_options).whenValidate({
                group: group
            }).done(function () {
                var formData = new FormData($('#km_purchase_form')[0]);
                //formData.set('action', 'km_purchase');
                $('#km_checkoutcart_detail').addClass('fieldday_ajax_processing');
                $this.postFormData(fieldday_ajax.ajax_url + "?action=km_purchase", formData, function (response) {
                    if (response.status == 'success') {
                        $(button).parents('.km_purchase_form_content').html(response.content);
                        $this.scrollTo('.km_session_purchase');
                    } else {
                        $this.DisplayAlert('error', response.message);
                    }
                });
            });
        },
        process_purchaseDetail: function (button, event) {
            event.preventDefault();
            var group = $(button).data('group');
            $(button).parents('form').parsley($this.settings.parsley_valiation_options).whenValidate({
                group: group
            }).done(function () {
                if ($this.paymentrequired === true) {
                    var form = $(button).parents('form');
                    $this.StripeProcess(form, function (response) {
                        if (response.error) {
                            $this.DisplayAlert('error', response.error.message);
                        } else {
                            $('#_stripeToken').val(response.id);
                            $this.NextStep();
                        }
                    });
                } else {
                    $this.NextStep();
                }
            });
        },
        StripeProcess: function (form, callback) {
            var cardinfo = {};
            cardinfo.number = form.find('.km_card_number').val();
            cardinfo.cvc = form.find('.km_card_cvc').val();
            cardinfo.exp_month = form.find('.km_card_expiry_month').val();
            cardinfo.exp_year = form.find('.km_card_expiry_year').val();
            /* create stripe token*/
            $this.km_loader();
            Stripe.card.createToken(cardinfo, function (status, response) {
                $this.makeCall(fieldday_ajax.ajax_url + "?action=km_process_stripe", {
                    token: response.id
                }, function () {

                }, false);
                callback(response);
                $this.kmRemoveLoader();
            });
        },
        getSchoolData: function (elem, event, grade, track) {
            var schoolId = $(elem).val();
            var parentDiv = $(elem).parents('.km_kids_fields_wrap');
            if (schoolId) {
                $this.makeCall(fieldday_ajax.ajax_url, {
                    action: 'get_school_info',
                    schoolId: schoolId
                }, function (response) {
                    if (response.status == 'success') {
                        parentDiv.find('.km_school_grades, .km_school_tracks').remove();
                        if (response.schools.grades.length) {
                            var fieldwrap = $("<div class='km_col_4 km_field_wrap km_school_grades'>").appendTo(parentDiv);
                            fieldwrap.append('<label>Grade</label>');
                            var sel = $('<select data-name="grade" class="km_input" name="' + grade + '">').appendTo(fieldwrap);
                            $.each(response.schools.grades, function (i, grade) {
                                sel.append($('<option></option>').val(grade).html(grade));
                            });
                        }
                        if (response.schools.tracks.length) {
                            var fieldwrap = $("<div class='km_col_4 km_field_wrap km_school_tracks'>").appendTo(parentDiv);
                            fieldwrap.append('<label>Track</label>');
                            var sel = $('<select data-name="track" class="km_input" name="' + track + '">').appendTo(fieldwrap);
                            $.each(response.schools.tracks, function (i, track) {
                                var newtrack = track.replace("track_", "");
                                sel.append($('<option></option>').val(track).html(newtrack));
                            });
                        }
                    } else {
                        $this.DisplayAlert('error', response.message);
                    }
                });
            } else {
                parentDiv.find('.km_school_grades, .km_school_tracks').remove();
            }

        },
        openClaimForm: function (button, event) {
            event.preventDefault();
            $this.makeCall(fieldday_ajax.ajax_url, {
                action: 'km_display_claim_form'
            }, function (response) {
                if (response.status == 'success') {
                    $this.displayModal(response);
                } else if (response.status == 'fail') {
                    $this.DisplayAlert('error', response.message);
                }
            });
        },
        claimStoreCredit: function (button, event) {
            event.preventDefault();
            var formData = new FormData($('#km_claimForm')[0]);
            //formData.set('action', 'km_updateCart');
            $(button).parents('form').parsley($this.settings.parsley_valiation_options).whenValidate({
                group: 'claim_code'
            }).done(function () {
                $(button).prop('disabled', true);
                $this.postFormData(fieldday_ajax.ajax_url + "?action=km_claimcredit", formData, function (response) {
                    if (response.status == 'success') {
                        $("#store_credit").trigger('click');
                        $this.closepopup();
                    } else {
                        $this.DisplayAlert('error', response.message);
                    }
                    $(button).prop('disabled', false);
                });

            });

        },
        UpdateCart: function () {
            var formData = new FormData($('#km_purchase_form')[0]);
            //formData.set('action', 'km_updateCart');
            $('#km_checkoutcart_detail').addClass('fieldday_ajax_processing');
            $this.postFormData(fieldday_ajax.ajax_url + "?action=km_updateCart", formData, function (response) {
                if (response.status == 'success') {
                    $('#km_checkoutcart_detail').removeClass('fieldday_ajax_processing').html(response.content);
                    /* remove payment options if payble amout is 0*/
                    if (response.data.payableAmount == 0) {
                        $('.km_payment_column').hide();
                        $('#_stripeToken').remove();
                        $this.paymentrequired = false;
                        $('.km_payment_column').find('input, textarea, select').removeAttr('required');
                        $('.km_checkout_conf_pricedetail').html(response.data.pricedetail);
                    } else {
                        $this.paymentrequired = true;
                        $('.km_payment_column').show();
                        if (!$('#_stripeToken').length) {
                            $('.km_purchase_form').prepend("<input type='hidden' name='stripeToken' value='' id='_stripeToken'>");
                        }
                        $('.km_payment_column').find('input:not(.optional), textarea:not(.optional), select:not(.optional)').attr('required', true);
                        $('.km_checkout_conf_pricedetail').html(response.data.pricedetail);
                        $('.km_checkout_conf_carddetail').html(response.data.cardinfo);
                    }
                    $('.km_default_authpickup').html(response.data.authPickups);
                } else {
                    $this.DisplayAlert('error', response.message);
                    $('#km_checkoutcart_detail').html(response.message).removeClass('fieldday_ajax_processing');
                    $this.paymentrequired = false;

                }
            });
        },
        PrevStep: function () {
            $('._purchase_steps .km_step:eq(' + $currentstep + ')').removeClass('km_active_step');
            $currentstep--;
            $('.km_single_step').removeClass('km_active_step');
            $('.km_purchase_form_content .km_single_step:eq(' + $currentstep + ')').addClass('km_active_step');
            $this.scrollTo('.km_session_purchase');
        },
        NextStep: function () {
            $currentstep++;
            $('.km_single_step').removeClass('km_active_step');
            $('.km_purchase_form_content .km_single_step:eq(' + $currentstep + ')').addClass('km_active_step');
            $('._purchase_steps .km_step:eq(' + $currentstep + ')').addClass('km_active_step');
            $this.scrollTo('.km_session_purchase');
        },
        DisplayAlert: function (type, message) {
            if (type == 'success' || type == 'error') {
                $('.km_alert_message').removeClass('km_alert_success km_alert_error');
                $('.km_alert_message').html(message).show().addClass('km_bounce km_alert_' + type);
                setTimeout(function () {
                    $(".km_alert_message").hide();
                }, 5000);
            }
        },
        DisplayMessage: function (button, type, message) {
            $(".km_inline_message").remove();
            if (type == 'success' || type == 'error') {
                $(button).parents('form').prepend("<div class='km_inline_message'>" + message + "</div>");
                $(".km_inline_message").show().addClass('km_alert_' + type);
            }
        },
        displayModal: function (response, sizeClass) {

            if (!sizeClass) {
                sizeClass = 'modal-normal';
            }
            if (response.header) {
                $('#km_modal .km_modal_heading').html(response.header).show();
            } else {
                $('#km_modal .km_modal_heading').hide();
            }
            if (response.content) {
                $('#km_modal .km_modal_content').html(response.content);
            }
            if (response.footer) {
                $('#km_modal .km_modal_footer').html(response.footer).show();
            } else {
                $('#km_modal .km_modal_footer').hide();
            }
            if ($('#km_modal .km_modal_content .km_phone_field').length) {
                $('#km_modal .km_modal_content').addClass("km_showoverflow");
            } else {
                $('#km_modal .km_modal_content').removeClass("km_showoverflow");
            }
            $(".km_modal_content").animate({
                scrollTop: 0
            }, "fast");
            $('#km_modal').removeAttr('class').addClass("km_overlay " + sizeClass).show();
        },
        processSessionFilters: function (elem, event) {
            let isProcessing = false;
            if (isProcessing === false) {
                isProcessing = true;
                var formData = new FormData($('#km_session_filter_form')[0]);
                //formData.set('action', 'km_reset_password');
                $this.postFormData(fieldday_ajax.ajax_url + "?action=km_filtersession", formData, function (response) {
                    if (response.status == 'success') {
                        $('.km_provider_sessions').show();
                        $('.km_provider_merchandise').hide();
                        /*var newUrl = $this.addQueryVar(location.href, 'session_type', tagId);
                         Â history.pushState({}, null, newUrl);*/
                        $('.km_provider_sessions').html(response.content);
                        $this.fielddaySessionTime();
                        isProcessing = false;

                        let totalrows = $(".km_session_single_item").length;
                        if (totalrows == 0) {
                            $('#km_nosession_message').removeClass('km_hidden');
                        } else {
                            $('#km_nosession_message').addClass('km_hidden');
                        }
                    } else if (response.status == 'fail') {
                        $this.DisplayAlert('error', response.message);
                    }
                });
            }
        },
        FilterSessions: function () {
            $('#km_session_search_keyword').on('keyup', function (event) {
                clearTimeout($typingTimer);
                $typingTimer = setTimeout(function () {
                    $this.processSessionFilters($this, event);
                }, 2000);

            });
            $('#km_session_search_keyword').on('keydown', function (event) {
                clearTimeout($typingTimer);
            });
            $(document).on('click', '.km_reset_filter', function () {
                let filtername = $(this).data('filter-key');
                let resetValue = 'all';
                if (filtername == 'searchKey') {
                    resetValue = '';
                }
                $('[data-search-name="' + filtername + '"]').val(resetValue);
                $this.processSessionFilters();
            });
        },
        mobileSessionTabs: function (elem, event) {
            let tabValue = $(elem).val();
            if (tabValue == 'bankDays') {
                $this.showMerchandise(elem, event);
            } else {
                event.preventDefault();
                $('#km_session_tab_id').val(tabValue);
                $this.processSessionFilters();
            }
        },
        showMerchandise: function (elem, event) {
            $('.km_session_tab').removeClass('km_active_tab');
            $(event).addClass('km_active_tab');
            $this.makeCall(fieldday_ajax.ajax_url, {
                action: 'km_get_bankdays'
            }, function (response) {
                if (response.status == 'success') {
                    $('.km_provider_sessions').html(response.content).show();
                } else if (response.status == 'fail') {
                    $this.DisplayAlert('error', response.message);
                }
            });
        },
        km_loader: function () {
            if ($('.km_loader_full').length) {
                $('.km_loader_full').show();
            } else {
                $('body').append($this.settings.loader);
            }
        },
        kmRemoveLoader: function () {
            $('.km_loader_full').hide();
        },
        GetQueryString: function (sParam) {
            var sPageURL = window.location.search.substring(1),
                    sURLVariables = sPageURL.split('&'),
                    sParameterName,
                    i;
            if (sURLVariables) {
                for (i = 0; i < sURLVariables.length; i++) {
                    sParameterName = sURLVariables[i].split('=');
                    if (sParameterName[0] === sParam) {
                        return sParameterName[1] === undefined ? true : decodeURIComponent(sParameterName[1]);
                    }
                }
            }
            return false;
        },
        removeQueryParam: function (key) {
            // separating the key-value ('search') portion of the URL from the rest:
            var url = window.location.href;
            var urlParts = url.split('?');
            // if we have only a single array-element, or if the key to remove
            // is not found in the URL, we quit here and return the same unchanged URL:
            if (urlParts.length === 1 || url.indexOf(key) === -1) {
                // there were no parameters, or the
                // key wasn't present
                return url;
            } else {
                // otherwise, we split the key-value string on the '&' characters,
                // for an array of key=value strings:
                var keyValues = urlParts[1].split('&'),
                        // filtering that array:
                        refinedKeyValues = keyValues.filter(function (keyValuePair) {
                            // keeping only those array elements that don't /start with/
                            // the key to be removed:
                            return keyValuePair.indexOf(key) !== 0;
                            // joining the key=value pairs back into a string:
                        }).join('&');
            }
            // returning the refined URL:
            if (refinedKeyValues) {
                var refinedUrl = urlParts[0] + '?' + refinedKeyValues;
            } else {
                var refinedUrl = urlParts[0];
            }

            //return refinedUrl;
            if ("undefined" !== typeof history.pushState) {
                history.pushState({}, "", refinedUrl);
            } else {
                window.location.assign(refinedUrl);
            }

        },
        viewSessionDetail: function (sessionId) {
            let tags = $('#km_session_tags').val();
            $this.makeCall(fieldday_ajax.ajax_url, {
                sessionId: sessionId,
                tags: JSON.parse(tags),
                'action': 'km_session_detail'
            }, function (response) {
                if (response.status == 'success') {
                    $this.displayModal(response, 'modal-large');
                    $this.initSlickSlider();
                    $this.fielddaySessionTime();
                    $this.addParamToUrl('sessionId', sessionId);
                    $this.kmTooltip();
                } else {
                    $this.DisplayAlert('error', response.message);
                    $this.closepopup();
                }
            });
        },
        addParamToUrl: function (key, value) {
            let url = $this.addQueryVar(fieldday_ajax.permalink, key, value);
            if ("undefined" !== typeof history.pushState) {
                history.pushState({}, "", url);
            } else {
                window.location.assign(url);
            }
        },
        sessionBookingOptions: function (sessionId) {
            let tags = $('#km_session_tags').val();
            $this.makeCall(fieldday_ajax.ajax_url, {
                sessionId: sessionId,
                tags: JSON.parse(tags),
                'action': 'km_session_booking_options'
            }, function (response) {
                if (response.status == 'success') {
                    $this.displayModal(response);
                    $this.initSlickSlider();
                } else {
                    $this.DisplayAlert('error', response.message);
                    $this.closepopup();
                }
            });
        },
        scrollTo: function (element, scrollelement) {
            if (!scrollelement) {
                scrollelement = 'html, body';
            }
            if ($(element).length) {
                $(scrollelement).animate({
                    scrollTop: $(element).offset().top
                }, 1000);
            }
        },
        initSlickSlider: function () {
            $('.km_slides').slick({
                dots: false,
                arrows: true,
                infinite: false,
                cssEase: 'linear'
            });
        },
        submitDonation: function (elem, event) {

            event.preventDefault();
            var form = $(elem).parents('form');
            form.parsley($this.settings.parsley_valiation_options).whenValidate({
                group: 'km_donate'
            }).done(function () {
                $(elem).prop('disabled', true);
                $this.StripeProcess(form, function (response) {
                    if (response.error) {
                        $this.DisplayAlert('error', response.error.message);
                    } else {
                        form.find('.stripe_token').val(response.id);
                        var formData = new FormData(form[0]);
                        //formData.set('action', 'km_reset_password');
                        $(button).prop('disabled', true);
                        $this.postFormData(fieldday_ajax.ajax_url + "?action=km_submit_donation", formData, function (response) {
                            if (response.status == 'success') {
                                form[0].reset();
                                $this.displayModal(response);
                                //grecaptcha.reset(1);
                            } else if (response.status == 'fail') {
                                $this.DisplayAlert('error', response.message);
                            }
                            $(elem).prop('disabled', false);
                        });
                    }
                    $(elem).prop('disabled', false);
                });
            });
        },
        makeCall: function (url, data, callback, hideloader) {
            url = $this.addQueryVar(url, "permalink", fieldday_ajax.permalink);
            url = $this.addQueryVar(url, "_wpnonce", fieldday_ajax._wpnonce);
            $.ajax({
                url: url, // server url
                type: 'POST', //POST or GET
                data: data, // data to send in ajax format or querystring format
                datatype: 'json',
                async: true,
                crossDomain: true,
                beforeSend: function (xhr) {
                    if (!hideloader) {
                        $this.km_loader();
                    }
                },
                success: function (data) {
                    callback(data); // return data in callback
                },
                complete: function () {
                    if (!hideloader) {
                        $this.kmRemoveLoader();
                    }
                },

                error: function (xhr, status, error) {
                    $this.kmRemoveLoader();
                }

            });
        },
        postFormData: function (url, data, callback, hideloader) {
            //data.set('permalink', fieldday_ajax.permalink);
            //data.set('_wpnonce', fieldday_ajax._wpnonce);
            url = $this.addQueryVar(url, "permalink", fieldday_ajax.permalink);
            url = $this.addQueryVar(url, "_wpnonce", fieldday_ajax._wpnonce);
            $.ajax({
                url: url, // server url
                type: 'POST', //POST or GET
                data: data, // data to send in ajax format or querystring format
                datatype: 'json',
                beforeSend: function (xhr) {
                    if (!hideloader) {
                        $this.km_loader();
                    }
                },
                success: function (data) {
                    if (!hideloader) {
                        $this.kmRemoveLoader();
                    }
                    callback(data); // return data in callback
                },

                complete: function () {

                },

                error: function (xhr, status, error) {
                    $this.kmRemoveLoader();
                },
                cache: false,
                contentType: false,
                processData: false

            });
        },
        addQueryVar: function (uri, key, value) {
            var re = new RegExp("([?&])" + key + "=.*?(&|$)", "i");
            var separator = uri.indexOf('?') !== -1 ? "&" : "?";
            if (uri.match(re)) {
                return uri.replace(re, '$1' + key + "=" + value + '$2');
            } else {
                return uri + separator + key + "=" + value;
            }
        },
        initilaizeDaterangepicker: function () {
            var start = moment();
            var end = moment().add(29, 'days');
            function cb(start, end) {
                $('#reportrange span').html(start.format('MMM D, YYYY') + ' - ' + end.format('MMM D, YYYY'));
            }
            $('#reportrange').daterangepicker({
                startDate: start,
                endDate: end,
                minDate: moment(),
                ranges: {
                    'Today': [moment(), moment().startOf('hour').add(23, 'hour')],
                    'Next 7 Days': [moment().startOf('hour').add(15, 'hour').add(6, 'days'), moment()],
                    'Next Month': [moment().add(1, 'month').startOf('month'), moment().add(1, 'month').endOf('month')]
                }
            }, cb);

            cb(start, end);
        },
        SessionlistVeiw: function () {
            $('.km_session_switcher').on('click', function (event) {
                $('.km_session_switcher').removeClass('km_current_layout');
                var style = $(this).data('style');
                $(this).addClass('km_current_layout');
                if (style == 'grid') {
                    $('.km_shadow_right').removeClass('km_session_list');
                } else {
                    $('.km_shadow_right').removeClass('km_session_grid');
                }
                $('.km_shadow_right').addClass('km_session_' + style);
            });
            let isStickyHeader = false;
            $(document).scroll(function () {
                if ($(this).scrollTop() < 50) {
                    isStickyHeader = false;
                }
                if (isStickyHeader && $this.inRange($(this).scrollTop(), 45, 55)) {
                    return;
                }
                if ($(this).scrollTop() > 50) {
                    isStickyHeader = true;
                    $('.km_sessions_header').addClass('km_session_sticky_header');
                } else {
                    isStickyHeader = false;
                    $('.km_sessions_header').removeClass('km_session_sticky_header');
                }
            });
            $('.km_discount_button').on('click', function () {
                $this.setCookie('discount_check', true);
                $('#km_modal_discount').hide();
            });
            $('.km_global_pop_btn').on('click', function (event) {
                event.preventDefault();
                $this.setCookie(fieldday_ajax.global_popup_key, true);
                $('#km_modal_discount_global').hide();
                let link = $(this).attr('href');
                if (link) {
                    window.location.href = link;
                }
            });

            $('.km_session_tab').on('click', function (event) {
                event.preventDefault();
                let tabId = $(this).data('id');
                $('.km_session_tab, .km_session_tab_merchandise').removeClass('km_active_tab');
                $('#km_session_tab_id').val(tabId);
                $(this).addClass('km_active_tab');
                $this.processSessionFilters();
            });


            /*list filter script start */
            $(document).on('click', '#filter_type_types', function (e) {
                e.preventDefault();
                jQuery('.km_bank_type').removeClass('activefilter');
                jQuery('.km_custom_dropdown.filter_list_dropdown').removeClass('activefilter');
                jQuery(this).next('.typescontent').toggleClass('activefilter');
            });

            $(document).on('click', '#filter_type_bankdays', function (e) {
                e.preventDefault();
                jQuery('.typescontent').removeClass('activefilter');
                jQuery('.km_custom_dropdown.filter_list_dropdown').removeClass('activefilter');
                jQuery(this).next('.km_bank_type').toggleClass('activefilter');
            });

            jQuery('#filter_type_month').on('click', function (e) {
                e.preventDefault();
                jQuery('.typescontent').removeClass('activefilter');
                jQuery('.km_bank_type').removeClass('activefilter');

                jQuery(this).next('.km_custom_dropdown.filter_list_dropdown').toggleClass('activefilter');
            });

            $(document).mouseup(function (e) {
                var container = $("#filter_type_types,#filter_type_bankdays,#filter_type_month,.km_custom_dropdown.filter_list_dropdown,.typescontent,.km_bank_type");
                if (!container.is(e.target) && container.has(e.target).length === 0) {
                    jQuery('.typescontent').removeClass('activefilter');
                    jQuery('.km_custom_dropdown.filter_list_dropdown').removeClass('activefilter');
                    jQuery('.km_bank_type').removeClass('activefilter');
                }

                $(document).ajaxStart(function () {
                    jQuery('.typescontent').removeClass('activefilter');
                    jQuery('.km_custom_dropdown.filter_list_dropdown').removeClass('activefilter');
                    jQuery('.km_bank_type').removeClass('activefilter');
                });
            });

            $('#reportrange').on('apply.daterangepicker', function (ev, picker) {
                var startDate = picker.startDate.format('MM-DD-YYYY');
                var endDate = picker.endDate.format('MM-DD-YYYY 23:59:59');
                var formData = new FormData($('#km_session_filter_form')[0]);
                if (startDate > endDate) {

                    $('#reportrange span').html(picker.endDate.format('MMMM D, YYYY') + ' - ' + picker.startDate.format('MMMM D, YYYY'));
                    formData.append('filters[fromDate]', endDate);
                    formData.append('filters[toDate]', startDate);
                } else {
                    var Todaystart = picker.startDate.format('MM-DD-YYYY 23:59:59');
                    var TodayendDate = picker.endDate.format('MM-DD-YYYY 23:59:59');

                    $('#reportrange span').html(picker.startDate.format('MMMM D, YYYY') + ' - ' + picker.endDate.format('MMMM D, YYYY'));
                    formData.append('filters[fromDate]', Todaystart);
                    formData.append('filters[toDate]', TodayendDate);
                }
                $this.postFormData(fieldday_ajax.ajax_url + "?action=km_filtersession", formData, function (response) {
                    if (response.status == 'success') {
                        $('.km_provider_sessions').show();
                        $('.km_provider_merchandise').hide();
                        $('.km_provider_sessions').html(response.content);
                        $this.fielddaySessionTime();
                        isProcessing = false;

                        let totalrows = $(".km_session_single_item").length;
                        if (totalrows == 0) {
                            $('#km_nosession_message').removeClass('km_hidden');
                        } else {
                            $('#km_nosession_message').addClass('km_hidden');
                        }
                    } else if (response.status == 'fail') {
                        $this.DisplayAlert('error', response.message);
                    }

                });

            });
            var windowWidth = window.screen.width < window.outerWidth ?
                    window.screen.width : window.outerWidth;
            var mobile = windowWidth < 500;
                $('#km_events_calendar').fullCalendar({
                    header: {
                        left: '',
                        center: 'title',
                    },
                    eventRender: function (event, element, view) {
                        console.log(event);
                    },
                    events: function (start, end, timezone, callback) {
                      var moments = moment().subtract(7, 'days');
                      var ends = moment().add(50, 'days');
                        jQuery.ajax({
                            url: fieldday_ajax.ajax_url + '?action=km_calenderevents',
                            type: 'POST',
                            dataType: 'json',
                            data: {
                                start: moments.format('MM-DD-YYYY 23:59:59'),
                                end: ends.format('MM-DD-YYYY 23:59:59')
                            },
                            success: function (doc) {
                                var events = [];
                                $.each(doc, function (i, item) {
                                    let startTimeString = doc[i].start_fulldate;
                                    let endTimeString = doc[i].end_fulldate;
                                    let startDate = $this.convertTimeToLocal(startTimeString, "YYYY-MM-DD");
                                    let endDate = $this.convertTimeToLocal(endTimeString, "YYYY-MM-DD");
                                    let startTime = $this.convertTimeToLocal(startTimeString, "h:mm a");
                                    let endTime = $this.convertTimeToLocal(endTimeString, "h:mm a");
                                    events.push({
                                        id: doc[i].id,
                                        title: doc[i].title,
                                        start: startDate,
                                        end: endDate
                                    });
                                    var selectClass = $('td .fc-day-top');
                                    $.each(selectClass, function () {
                                        var dateevent = $(this).attr('data-date');
                                        var eventweek = $this.convertTimeToLocal(dateevent+ " 05:00", "dddd");
                                        let indexNumber = $this.settings.DaysArray.indexOf(eventweek);
                                        //var eventweekcount = eventweek.getDay();

                                        if (dateevent <= endDate && dateevent >= startDate) {
                                            $(this).attr('data-weekday', eventweek);
                                            if( $.inArray(indexNumber, doc[i].days) > -1) {
                                              if(mobile){
                                                $(this).append('<div class="eventtitle km_session_single_item" data-time-stamp-from=\"' + doc[i].starttimestamp + '\" data-time-stamp-to=\"' + doc[i].endtimestamp + '\" ><a class="km_eventclick" href="javascript:void(0);" data_eventid=\"' + doc[i].id + '\" ><span style="color:#'+doc[i].title_color+';display: block;font-weight: bold;">' + doc[i].title + '</span></a><span class="km_event_time">'+startTime+'-'+endTime+'</span></div>');
                                                var length = $('.eventtitle').length;
                                                var height = document.querySelector('.eventtitle').offsetHeight
                                                $('.fc-view.fc-agendaDay-view.fc-agenda-view .fc-row.fc-week.fc-widget-content').css('height', height * length + 50);
                                              }else {
                                                  $(this).find('.fc-day-number').after('<div class="eventtitle km_session_single_item" style="margin: 5px 3px;" data-time-stamp-from=\"' + doc[i].starttimestamp + '\" data-time-stamp-to=\"' + doc[i].endtimestamp + '\" ><a class="km_eventclick" href="javascript:void(0);" data_eventid=\"' + doc[i].id + '\" ><span style="color:#'+doc[i].title_color+';display: block;font-weight: bold;white-space: break-spaces;">' + doc[i].title + '</span></a><span class="km_event_time">'+startTime+'-'+endTime+'</span></div>');
                                              }

                                            }

                                        }

                                    });
                                });


                            }

                        });
                    }

                });
                $(document).ajaxStop(function () {
                    $('body').on('click', '.km_eventclick', function (e) {
                        e.stopPropagation();
                        e.stopImmediatePropagation();
                        var sessionId = $(this).attr('data_eventid');

                        $this.makeCall(fieldday_ajax.ajax_url, {
                            sessionId: sessionId,
                            'action': 'km_session_detail'
                        }, function (response) {
                            if (response.status == 'success') {
                                $this.displayModal(response, 'modal-large');
                                $this.initSlickSlider();
                                $this.fielddaySessionTime();
                                $this.kmTooltip();
                            } else {
                                $this.DisplayAlert('error', response.message);
                                $this.closepopup();
                            }
                        });
                    });

                });

            /*-- mobile cart view code  --*/
            $(document).ajaxStop(function () {
                $('body').on('click', '.removecartselecter', function (e) {
                    e.stopPropagation();
                    jQuery('#km_cart_items_wrap').css({right: '-300px'});
                    jQuery('#km_cart_items_wrap_mobile').css({top: '5000px'});

                });
            });

            /*-- mobile cart view code  --*/
            /* list filter script end */
            $('body').on('click', 'i#sharesession',function (e) {

                var inputc = document.body.appendChild(document.createElement("input"));
                    var searchParams = $('.km_booking_type.km_col_3.km_tooltip a').attr('href');
                    var newParams  = searchParams.replace("_id","sessionId");
                    //console.log('',newParams);
                    inputc.value = newParams;
                    inputc.focus();
                    inputc.select();
                    document.execCommand('copy');
                    inputc.parentNode.removeChild(inputc);
                     $this.DisplayAlert('success', 'session link has been copied');
                    //alert("SessionUrl Copied.");
            });

        },
        convertTimeToLocal: function(timeString, format) {
            return moment.utc(timeString).local().format(format);
        },
        filterByTag: function (elem, event) {
            let tagname = $(elem).prop("tagName");
            if (tagname == 'SELECT') {
                $this.processSessionFilters();
            } else {
                $('.km_radio_wrap_filterd').removeClass('km_active_filter');
                $(elem).parents('.km_radio_wrap_filterd').addClass('km_active_filter');
                $this.processSessionFilters();
            }
        },
        Myaccountpageevents: function () {
            $('.close_before_account_text').on('click', function () {
                $this.setCookie('display_account_help', true);
                $('.km_before_account_text').remove();
            });
        },
        radiobuttonevent: function (button, event) {
            var previousValue = $(button).attr('previousValue');
            if (previousValue == 'true') {
                button.checked = false;
                $(button).attr('previousValue', button.checked);
            } else {
                button.checked = true;
                $(button).attr('previousValue', button.checked);
            }
        },
        giftCardswitchevent: function()
        {
              $("body").on("click",'.km_single_giftcardpopup .km_single_giftdesign img', function(e)
              {
                e.preventDefault();
                $('.km_single_giftdesign').removeClass('selectedCartItem');
                var selectGiftImage=$(this).data('original');
                var selectGiftImagethumb=$(this).attr('src');
                $('.km_single_giftcardpopup .km_gift_image').attr('src', selectGiftImagethumb);
                $('.km_single_giftcardpopup .km_gift_image').attr('data-original', selectGiftImage);
                $(this).parent('.km_single_giftcardpopup .km_single_giftdesign').addClass('selectedCartItem');
              });

              $("body").on("click",'.km_gift_value', function(e)
              {
                  e.preventDefault();
                  $('span.km_gift_value.selectedCartItem').removeClass('selectedCartItem');
                  var selectGiftprice=$(this).text();
                  if(selectGiftprice.trim() == ''){
                      $('input#km_gift_custom_amount').keyup(function() {
                        selectGiftprice = this.value;
                        $('.a-alert-content').text('');
                        if (/\D/g.test(this.value))
                         {
                           // Filter non-digits from input value.
                           this.value = this.value.replace(/\D/g, '');
                         }else{
                                var max = parseInt($(this).attr('max'));
                                var min = parseInt($(this).attr('min'));
                                if ($(this).val() > max)
                                {
                                //$('.a-alert-content').text('This is over the $2000 maximum');
                                }
                                else if ($(this).val() < min)
                                {
                                //$('.a-alert-content').text('The minimum amount is $1');
                                }
                             var amount="$" + parseFloat(selectGiftprice).toFixed(2).replace(/\d(?=(\d{3})+\.)/g, "$&,");
                             $('.giftcardprice').text(amount);
                             $('.input#km_gift_custom_amount').val(amount);

                         }

                      });
                      $(this).addClass('selectedCartItem');
                    }else{
                      $('.giftcardprice').text(selectGiftprice);
                      $(this).addClass('selectedCartItem');
                    }
              });

              $("body").on("click",'.km_sendoption_value', function(e)
              {
                  e.preventDefault();
                  $('span.km_sendoption_value.selectedCartItem').removeClass('selectedCartItem');
                  $(this).addClass('selectedCartItem');
                  var sendMethod= jQuery('span.km_sendoption_value.selectedCartItem').text();
                  if(sendMethod != 'Email'){
                    $('span#phone_number').css('display',"block");
                    //$('span#email').css('display',"none");
                  }else{
                    $('span#phone_number').css('display',"none");
                    //$('span#email').css('display',"block");
                  }
              });

      },

        passwordHideShowevent: function(){
        //  const togglePassword = document.querySelector('#togglePassword');
          $("body").on("click",'#togglePassword', function(e){
           // toggle the type attribute
           var  password = document.querySelector("[name='user_password']");
           if(password === null){
                password = document.querySelector("[name='user-register-password']");
           }
            const type = password.getAttribute('type') === 'password' ? 'text' : 'password';
            password.setAttribute('type', type);
            // toggle the eye / eye slash icon
            if(type == 'text'){
            $(this).addClass('fa-eye').removeClass('fa-eye-slash');
            }else{
            $(this).addClass('fa-eye-slash').removeClass('fa-eye');
            }

          });

        }


    };

    fieldday.initilaize();
})(jQuery);
