<div id="<?php echo $step['name']; ?>" class="<?php echo $step['classes']; ?>">
    <h2 class="km_progress_header"><?php echo $step['label']; ?></h2>
    <div class="km_order_confirmation_text km_progress_confirmation"> 
        <div class="km_row">
            <div class="km_col_6">
                <div class="km_price_breakdown">
                    <h2><?php _e('Purchase Detail', 'fieldday'); ?></h2>
                    <div class="km_tab km_checkout_conf_pricedetail">

                    </div>
                </div>
                
            </div>
            <div class="km_col_6">
                <div class="km_authorized">
                    <h2><?php _e('Authorized To Pick Up', 'fieldday'); ?></h2>
                    <div class="km_col_8">
                        <div class="km_default_authpickup">
                            
                        </div>
                    </div>
                    <div class="km_col_8 km_field_wrap">
                        <span><?php print apply_filters('fieldday_authpickup_text', __("Do you wish to have family member or friend do the pickup?", 'fieldday')); ?></span>
                    </div>
                    <div class="km_col_8 km_field_wrap">
                        <label for="km_name"><?php _e('Name', 'fieldday'); ?></label>
                        <input type="text" name="authPickUps[0][name]" data-parsley-group="<?php echo $step['name']; ?>" class="km_input">
                    </div>
                    <div class="km_col_8 km_field_wrap">
                        <label for="km_name"><?php _e('Phone Number', 'fieldday'); ?></label>
                        <input type="hidden" name="authPickUps[0][countryCode]" class="country_code" value="1">
                        <input type="hidden" name="authPickUps[0][phone]" class="phone_number" value="">
                        <input type="text" data-parsley-group="<?php echo $step['name']; ?>" class="km_input km_phone_field" id="pur_phone">
                    </div>
                </div>
            </div>
        </div>

        <hr class="km_hrline" />
        <div class="km_row">
            <div class="km_col_6">
                <div class="km_term_condition">
                    <label class='km_checkbox_wrap'>
                        <span><?php print wp_sprintf("%s <a class='km_provider_terms_display' href=''>%s</a>", __("I've read and accept the", 'fieldday'), __("terms & conditions", 'fieldday')); ?></span>
                        <input required="required" name="km_terms_condition" data-parsley-required-message="Please accept terms & conditions" data-parsley-group="<?php echo $step['name']; ?>" type="checkbox" class="km_provider_terms km_checkboxteam" required="required">
                        <span class="km_checkbox"></span>
                    </label>
                    <div class="km_hidden">
                        <?php print $this->getProviderTerms($step['name']); ?>
                    </div>
                    
                </div>
            </div>
        </div>
    </div>


    <div class="km_btn_wrap">
        <a href="javascript:void(0);" class="km_next_step km_btn" onclick="return fieldday.PrevStep();"><?php $this->displayText('atc_prev_btn'); ?></a>
        <a href="javascript:void(0);" class="km_next_step km_btn" data-group="<?php echo $step['name']; ?>" onclick="return fieldday.process_purchase(this, event);"><?php _e("Place Your Order", 'fieldday'); ?></a>
    </div>
</div>