<?php 
$params = [];
if(isset($sessionId) && $sessionId) {
    $params[] = $sessionId;
}
if(isset($tagId) && $tagId) {
    $params[] = $tagId;
}
if(isset($sessionDate) && $sessionDate) {
    $params[] = $sessionDate;
}
if(isset($_REQUEST['sessionfeatured'])) {
$sessionfeatured = filter_input(INPUT_POST, 'sessionfeatured', FILTER_SANITIZE_STRING);
}
if(isset($offerId) && $offerId) {
    $params = [null, null, null];
    $params[] = $offerId;
}

?>
<div class="km_login_wrap km_authpop_wrap">
    <?php do_action('km_before_loginpage'); ?>
    <div class="login_row">
        <div class="<?php if(isset($_POST['isGuest'])){ echo "km_col_6 membership ";}else{ echo "km_col_4 "; }?>km_register_module">
            <div class="km_register_sec">
                <h3 class="km_login_m_title">
                    <?php _e('New Customers', 'fieldday'); ?>
                </h3>
                <div class="km_login_m_features">
                    <span><?php _e('- Track Orders, Refunds & Tax.', 'fieldday'); ?></span>
                    <span><?php _e('- Get Notified and Stay Engaged.', 'fieldday'); ?></span>
                    <span><?php _e('- Quick Checkout with Profile.', 'fieldday'); ?></span>
                </div>
                <div class="km_login_m_button">
                    <a class="km_toggle_register km_button" onclick="return fieldday.showRegisterForm(this, event);" href="JavaScript:void(0);">Create My Account</a>
                </div>
            </div>
        </div>
        <div class="<?php if(isset($_POST['isGuest'])){ echo "km_col_6 membership ";}else{ echo "km_col_4 "; }?> km_login_module">
            <div class="km_login_sec">
                <h3 class="km_login_m_title">
                    <?php _e('Registered User', 'fieldday'); ?>
                </h3>
                <div class="km_login_m_features">
                    <span><?php _e('Have an account? Or fieldday account?', 'fieldday'); ?></span>
                    <span><?php _e('Welcome Back! Sign In Now.', 'fieldday'); ?></span>
                </div>
                <div class="km_login_m_button">
                    <a data-session-featured="<?php echo $sessionfeatured; ?>" data-session-date="<?= $sessionDate; ?>" 
                        data-session-date="<?php echo $sessionDate; ?>" <?php if(isset($_POST['isGuest'])){ echo "data-session-isGuest=true";} ?> onclick="return fieldday.showLoginForm(this, event );" class="km_toggle_sigh-in km_btn km_btn_green" href="JavaScript:void(0);">Sign In</a>
                </div>
            </div>    
        </div>
           <?php if(!$_POST['isGuest']){?>
        <div class="km_col_4 km_guest_module">
            <h3 class="km_login_m_title">
                <?php _e('Guest Checkout', 'fieldday'); ?>
            </h3>
            <div class="km_login_m_features">
                <span><?php _e('- Some discounts and coupons might not work.', 'fieldday'); ?></span>
                <span><?php _e('- No Purchase History', 'fieldday'); ?></span>
            </div>
            <div class="km_login_m_button">
                <?php if(isset($offerId) && $offerId): ?>
                    <?php $Registerparams = wp_sprintf("data-offer-id='%s'", $offerId); ?>
                    <input type="hidden" id="login_form_offerId" value="<?php echo $offerId; ?>">
                    <a href="JavaScript:void(0);" <?php $this->merchandiseRegister($offerId, true, $sessionfeatured ); ?> id="guest-continue" class="km_button_default km_guest_login">
                        <?php _e('Continue as a Guest', 'fieldday'); ?>
                    </a>
                <?php endif; ?>
                <?php if(isset($sessionId) && $sessionId): ?>
                    <?php if(empty($sessionfeatured)){ ?>

                    <a href="JavaScript:void(0);" <?php $this->sessionRegister($sessionId, $tagId, $sessionDate,true,$sessionfeatured); ?> id="guest-continue" class="km_button_default km_guest_login">
                        <?php _e('Continue as a Guest', 'fieldday'); ?>
                    </a>
                

                <?php } else{ ?>

                <a href="JavaScript:void(0);"  data-session-id="<?= $sessionId; ?>" data-tag-id="<?php echo $tagId; ?>" data-session-date="<?php echo $sessionDate; ?>" data-session-featured="<?php echo $sessionfeatured; ?>"  onclick="return fieldday.registerSessionTiming(this, event );"  id="guest-continue" class="km_button_default km_guest_login">
                <?php _e('Continue as a Guest', 'fieldday'); ?>
                </a>


                <?php }?>
                <?php endif; ?>
            </div>
        </div>
           <?php }?>
    </div>
</div>