<?php

$session_extra = $this->GetSessionVar($session);
$sessionPrice = $session->price;
$sessionPriceRange = $session->activityId->priceRange;
$sessionPriceRangeFrom = $sessionPriceRange->from;
$sessionPriceRangeto = isset($sessionPriceRange->to) ? $sessionPriceRange->to : null;
$sessionDateFromFilter = date('n', strtotime($session->dateTimestamp->from));
$sessionDateToFilter = date('n', strtotime($session->dateTimestamp->to));
$oneDaySelectedDate = $this->getValue('oneDaySelectedDate', $session, false);
$agefrom = $session->ageRange->from ?? $session->activityId->ageRange->from;
$ageto = $session->ageRange->to ?? $session->activityId->ageRange->to;
//$description= $session->description;
//$description= substr_replace($description, "...", 250);

$themeimgFile = plugin_dir_url(__FILE__) . "/assets/images/icon.svg";
?>
<li id="km_session_two_coloum_layout" class="km_session_single_item activethemeview km_records" data-time-stamp-from="<?php echo $session->dateTimestamp->from; ?>" data-time-stamp-to="<?php echo $session->dateTimestamp->to; ?>" data-day-type="<?php echo $session_extra['activityType']; ?>" data-month-from="<?php echo $sessionDateFromFilter; ?>" data-month-to="<?php echo $sessionDateToFilter; ?>" data-age-from="<?php echo $agefrom; ?>" data-age-to="<?php echo $session->activityId->ageRange->to; ?>">

    <!-- New Design -->
    <!-- Img -->
    <div class="km_col_2">
        <div class="km_align">
            <div class="km_thumbnail_new">
                <?php $this->displaySessionThumb($session); ?>
            </div>
        </div>
    </div>

    <!-- Content -->
    <div class="km_col_10">
        <div class="km_Heading_content">
            <!-- Heading -->
            <div onclick="return fieldday.viewSessionDetail('<?php echo $session->_id; ?>');" class="km_full_age">
                <input type='hidden' id='km_session_tags' value='{}'>
                <h3 style="<?php echo isset($session->activityId->colorHex) ? 'color: #'.$session->activityId->colorHex : ''; ?>" class="km_session_name_heading km_with_tooltip" onclick="return fieldday.viewSessionDetail('<?php echo $session->_id; ?>');" ><?php echo $session->name; ?>
                    <!--div class="km_with_tooltip">
                   <img src="<?php echo $themeimgFile; ?>" class="km_icon_infor">

                <span class="tooltiptext">More Info About This Activity</span>
                  </div-->
                </h3>
                <div class="km_descri" style="display: none"><?php echo $session->description; ?></div>

                <div class="km_session_full_ages">
                    <span><?php _e("Age", 'fieldday'); ?></span>
                    <span class="session_age_group">
                        <?php print wp_sprintf("%dy - %dy", $agefrom, $ageto) ?>
                    </span>


                </div>

                <div class="km_month_date km_month_year">
                    <!--i class="fa fa-calendar GridIcon" aria-hidden="true"></i>
                    <span class="time km_session_month"></span>
                    <span class="year km_session_year"></span-->
                </div>

                <div class="km_avaiableseats_session_section">
                    <a href="javascript:void(0);"  onclick="return fieldday.viewSessionDetail('<?php echo $session->_id; ?>');" class="km_session_btn km_moreinfor">More Info</a>
                </div>

            </div>
            <div class="km_Heading_content_inner">
                <div class="km_full_age_days">
                    <div class="km_session_days">
                        <span class="activity_title" style="display: none;"><?php echo apply_filters("km_sessionlist_activity_title", $session_extra['activityTitle'], $session, $session_extra); ?></span>
                        <span class="km_session_days_wrap">
                            <?php $this->sessionDays($session); ?>
                        </span>
                    </div>
                </div>

                <div class="km_time">
                    <i class="fa fa-clock-o GridIcon" aria-hidden="true"></i>
                    <span class="time km_sess_time"></span>
                </div>

                <!-- Date -->
                <div class="km_month_date km_month_year">
                    <i class="fa fa-calendar GridIcon" aria-hidden="true"></i>
                    <span class="time km_session_month"></span>
                    <span class="year km_session_year"></span>
                </div>

                <div class="km_location_session_section">
                    <i class="fa fa-map-marker"></i>
                    <span class="km_location_session_details"><?php echo $location; ?></span>
                </div>

            </div>

            <div class="km_session_bottom_wrap km_listview_price_col">
                <div class="km_session_price_div">
                    <span class="price">
                        <i class="fa fa-usd GridIcon" aria-hidden="true"></i>
                        <?php echo $this->display_price($session->price); ?>
                        <?php
                        if (!empty($sessionPriceRangeTo)) :
                            wp_sprintf("- %s", $this->display_price($sessionPriceRangeTo));
                        endif;
                        ?>
                    </span>
                </div>
                <div class="km_avaiableseats_session_section">
                    <span class="session_seats <?php echo $session_extra['SeatsClass']; ?>"><?php echo $session->availableSpots; ?> <?php _e('Available Seat(s)', 'fieldday'); ?></span>
                </div>
                <div class="km_cart_button_p">
                        <?php if ($session->availableSpots) : ?>
                        <a <?php $this->sessionRegister($session->_id, $tagId, $oneDaySelectedDate); ?> href="javascript:void(0);" class="km_btn km_session_btn">
                        <?php $this->displayText('add_to_cart_btn'); ?>
                        </a>
                    <?php else: ?>
                        <a class="disabled km_btn km_session_btn"><?php _e('Registeration Full', 'fieldday'); ?></a>
<?php endif; ?>

                </div>


            </div>

        </div>
    </div>

    <!-- Add to cart -->



</li>
