var calendar;
(function($) {
    var $this;

    calendar = {
        settings: {

        },
        initilaize: function() {
            $this = calendar;
            $(window).on('elementor/frontend/init', function() {
                var FrontEndExtended = elementorModules.frontend.handlers.Base.extend({
                    run: function() {
                        $this.onInitMethods();
                    },
                    onInit: function() {
                        elementorModules.frontend.handlers.Base.prototype.onInit.apply(this, arguments);
                        console.log('FrontEndExtended onInit');
                        this.run();
                    },
                });
                elementorFrontend.hooks.addAction('frontend/element_ready/section', function($element) {
                      $this.giftCardSlider();
                    setTimeout(function() {
                        $this.onInitMethods();
                    }, 3000);
                });
            });
        },
        onInitMethods: function() {
            $this.resizeTiles();

        },
        resizeTiles: function() {
            var element = 'div#km_events_calendar';
            if (element.length) {

                jQuery(element).fullCalendar({
                    header: {
                        left: '',
                        center: 'title',
                    },
                    eventRender: function(event, element, view) {
                        console.log(event);
                    },

                    events: function(start, end, timezone, callback) {
                        var moment = jQuery('div#km_events_calendar').fullCalendar('getDate');
                        jQuery.ajax({
                            url: fieldday_ajax.ajax_url + '?action=km_calenderevents',
                            type: 'POST',
                            dataType: 'json',
                            data: {
                                start: moment.format('MM-DD-YYYY 23:59:59'),
                                end: end.format('MM-DD-YYYY 23:59:59')
                            },
                            success: function(doc) {
                                var events = [];
                                jQuery.each(doc, function(i, item) {
                                    //alert(doc.result[i].PageName);

                                    events.push({
                                        id: doc[i].id,
                                        title: doc[i].title,
                                        start: doc[i].start,
                                        end: doc[i].end
                                    });

                                    var foo = jQuery('td .fc-day-top');
                                    jQuery.each(foo, function() {
                                        var dateevent = jQuery(this).attr('data-date');

                                        var eventweek = new Date(dateevent);
                                var eventweekcount= eventweek.getDay();

                                    if (dateevent <= doc[i].end && dateevent >= doc[i].start
                                     &&  jQuery.inArray(eventweekcount, doc[i].days) !== -1) {
                                            jQuery(this).find('.fc-day-number').after('<div class="eventtitle km_session_single_item" data-time-stamp-from=\"' + doc[i].starttimestamp + '\" data-time-stamp-to=\"' + doc[i].endtimestamp + '\" ><a class="km_eventclick" href="javascript:void(0);" data_eventid=\"' + doc[i].id + '\" ><span style="display: block;font-weight: bold;">' + doc[i].title + '</span></a><span class="km_event_time"></span></div>');

                                        }
                                    });

                                });
                            }
                        });
                    }

                });

                jQuery(document).ajaxStop(function() {

                    if (jQuery('.eventtitle.km_session_single_item').length) {
                        jQuery('.eventtitle.km_session_single_item').each(function() {
                            var dateFrom = jQuery(this).attr('data-time-stamp-from'),
                                dateTo = jQuery(this).attr('data-time-stamp-to'),
                                programTime = jQuery(this).find('span.km_event_time'),
                                //Month From
                                convertedMonthFrom = moment.utc(dateFrom).local().format('MMM DD'),
                                //Month To
                                convertedMonthTo = moment.utc(dateTo).local().format('MMM DD'),
                                //Year
                                convertedYear = moment.utc(dateTo).local().format('YYYY'),
                                //Time From
                                convertedTimeFrom = moment.utc(dateFrom).local().format('h:mm a'),
                                //Time To
                                convertedTimeTo = moment.utc(dateTo).local().format('h:mm a');
                            if (dateFrom && dateTo) {
                                jQuery(programTime).html(convertedTimeFrom + ' - ' + convertedTimeTo);
                            }
                        });
                    }
                    jQuery('body').on('click', '.km_eventclick', function(e) {

                        e.stopPropagation();
                        e.stopImmediatePropagation();
                        var sessionId = $(this).attr('data_eventid');

                        $this.makeCall(fieldday_ajax.ajax_url, {
                            sessionId: sessionId,
                            'action': 'km_session_detail'
                        }, function(response) {
                            if (response.status == 'success') {
                                $this.displayModal(response, 'modal-large');
                                $this.initSlickSlider();
                                $this.fielddaySessionTime();
                                $this.kmTooltip();
                            } else {
                                $this.DisplayAlert('error', response.message);
                                $this.closepopup();
                            }

                        });

                    });

                });

            }

        },
        giftCardSlider:function(){
          $('.km_gift_image_slider').slick({
            dots: false,
            infinite: true,
            arrows:true,
            speed: 300,
            slidesToShow: 1,
            adaptiveHeight: false
          })
        },

    };

    calendar.initilaize();


})(jQuery);


/*jQuery(document).ajaxStop(function() {
        jQuery('.elementor-control-field input[type="text"]').keypress(function() {

            console.log('working');
        });

    });*/
