<div class="km_cart_wrap">
    <?php //echo "<pre>"; print_r($cartdata); die; ?>
    <?php foreach($calculationInfo->details as $index => $CalculationItem) : $cartItemDetail = $this->getCartItem($CalculationItem->bookingKey); ?>
      <div class="km_cart_item">
        <?php $hasPaymentOption = $this->getValue('selected_payment_option', $cartItemDetail, false) ?>
        <div class="my__purchase-details km_row">
            <div class="km_cart_session_name km_col_3">
                <?php apply_filters('fieldday_cart_item_title', $this->displayCartSessionName($cartItemDetail), $CalculationItem, $cartItemDetail); ?>
                <?php if($hasPaymentOption && $hasPaymentOption != 'full_amount') : ?>
                  <div class="km_checkout_installments km_col_6">
                    <p class="km_installments_heading">Payment with Installments <i class="fa fa-chevron-circle-down"  data-sessionId="<?php echo $CalculationItem->sessionId;?>" id="km_checkoutpayments"></i></p>
                  </div>
                <?php endif; ?>
            </div>
            <div class="km_cart_meta km_col_3">
                <?php apply_filters('fieldday_cart_additionalcharges', $this->displayAdditionalChargesOnCart($CalculationItem), $CalculationItem, $cartItemDetail); ?>
            </div>
            <div class="km_col_3">
                <?php apply_filters('fieldday_cart_extended_care', $this->displayExtendedCareOnCart($CalculationItem, $cartItemDetail), $CalculationItem, $cartItemDetail); ?>
            </div>
            <div class="km_col_3">
                <?php apply_filters('fieldday_cart_kids', $this->displayKidsOnCart($cartItemDetail), $CalculationItem, $cartItemDetail); ?>
            </div>
        </div>
        <div class="km_cart_price_row">
            <?php if($hasPaymentOption && $hasPaymentOption != 'full_amount') : ?>
                <div class="km_sess_total_price"><?php print wp_sprintf('%s <strong>%s</strong>', __('Deposit Price:', 'fieldday'), $this->display_price($CalculationItem->totalSessionPrice)); ?></div>
            <?php else: ?>
              <div class="km_sess_total_price"><?php print wp_sprintf('%s <strong>%s</strong>', __('Session Price:', 'fieldday'), $this->display_price($CalculationItem->totalSessionPrice)); ?></div>
            <?php endif; ?>
            <div class="km_sess_total_price"><?php print wp_sprintf('%s <strong>%s</strong>', __('Additional Charges: ', 'fieldday'), $this->display_price($CalculationItem->additionalChargePrice)); ?></div>
            <div class="km_sess_total_price"><?php print wp_sprintf('%s <strong>%s</strong>', __('Extended Care charges:', 'fieldday'), $this->display_price($CalculationItem->extendedCarePrice)); ?></div>
            <div class="km_sess_sibling"><?php print wp_sprintf('%s <strong>%s</strong>', __('Sibling Discount:', 'fieldday'), $this->display_price($CalculationItem->siblingDiscountAmount)); ?></div>
        </div>
    </div>
    <?php endforeach; ?>
    <div class="km_row km_total_price_wrap">
        <div class="km_total_price_inner km_col_12">
            <div class="km_sess_total_price"><?php print wp_sprintf('%s : <strong>%s</strong>', __('Purchase Price', 'fieldday'), $this->display_price($calculationInfo->totalAmount)); ?></div>
        <div class="km_sess_sibling"><?php print wp_sprintf('%s <strong>%s</strong>', __('Sibling Discount:' , 'fieldday'), $this->display_price($calculationInfo->siblingDiscount)); ?></div>
        <div class="km_sess_sibling"><?php print wp_sprintf('%s <strong>%s</strong>', __('Campaign Discount:' , 'fieldday'), $this->display_price($calculationInfo->campaignDiscount)); ?></div>
        <div class="km_sess_total_price"><?php print wp_sprintf('%s <strong>%s</strong>',__('Credit Applied:', 'fieldday'), $this->getCreditApplied($calculationInfo)); ?></div>
        <div class="km_sess_payable_price"><?php print wp_sprintf('%s <strong>%s</strong>', __('Price Payable Today:', 'fieldday'), $this->display_price($calculationInfo->payableAmount)); ?></div>
        </div>

    </div>
</div>
