<div id="<?php echo $step['name']; ?>" class="<?php echo $step['classes']; ?>">
    <h2 class="km_progress_header"><?php echo $step['label']; ?></h2>
    <div class="km_session_cart">
        <div id="km_checkoutcart_detail" class="km_column_wrap km_col_12">
            
        </div>
        <div class="km_column_wrap km_payment_column km_col_6">
            <h3 class="km_heading"><?php _e('Payment Details', 'fieldday'); ?></h3>
            <div class="km_payment_wrap">
                <div class="km_col_8 km_field_wrap field_card_number">
                    <fieldset>
                        <label for="km_card_number"><?php _e('Card Number', 'fieldday'); ?></label>
                        <input type="text" maxlength="20" class="km_card_number km_input" id="km_card_number" data-stripe="number" data-parsley-required-message="Required" data-parsley-group="<?php echo $step['name']; ?>"  required="" />
                        <div class="km_card_type"></div>
                    </fieldset>
                </div>
                <div class="km_col_4 km_field_wrap field_card_cvv">
                    <fieldset class="">
                        <label for="km_cvv_code"><?php _e('CVV Code', 'fieldday'); ?></label>
                            <input type="text"  id="km_card_cvc" maxlength="4" class="km_card_cvc km_input" data-stripe="cvc" oninput="this.value = this.value.replace(/[^0-9.]/g, ''); this.value = this.value.replace(/(\..*)\./g, '$1');" data-parsley-group="<?php echo $step['name']; ?>" data-parsley-required-message="Required"  required=""   />
                    </fieldset>
                </div>
                <div class="km_col_12 km_field_wrap field_card_holdername">
                    <fieldset>
                        <label for="km_card_holder_name"><?php _e('Card Holder Name', 'fieldday'); ?></label>
                        <input type="text" id="card-holder-name" class="km_card_holder km_input" data-parsley-required-message="Required"  data-parsley-group="<?php echo $step['name']; ?>" required="" />
                    </fieldset>
                </div>
                <div class="km_col_6 km_field_wrap field_card_exp">
                    <fieldset>
                        <label><?php _e('Exp.Month', 'fieldday'); ?></label>
                        <div class="km_custom_dropdown">
                            <select id='km_expireMM' class= "km_card_expiry_month km_input" data-stripe="exp-month"  data-parsley-required-message="Required" data-parsley-group="<?php echo $step['name']; ?>" required="" >
                                <option value='' selected>Select</option>
                                <?php foreach($this->KmMonths() as $number => $monthName): ?>
                                <option value="<?php echo $number; ?>"><?php echo $monthName; ?></option>
                                <?php endforeach; ?>
                            </select> 
                        </div>
                    </fieldset>
                </div>
                <div class="km_col_6 km_field_wrap field_card_exp_year">
                    <fieldset>
                        <label><?php _e('Exp.Year', 'fieldday'); ?></label>
                        <div class="km_custom_dropdown">
                            <select class="km_card_expiry_year km_input" data-stripe="exp-year" data-parsley-group="<?php echo $step['name']; ?>" data-parsley-required-message="Required"  required=""  >
                                <option value=''>Select</option>
                                <?php 
                                for ($i = date('Y'); $i <= date('Y')+30; $i++) {
                                    echo '<option value="'.$i.'">'.$i.'</option>';
                                } ?>
                            </select> 
                        </div>
                    </fieldset>
                </div>
            </div>
        </div>
        <div class="km_column_wrap km_payment_column km_col_6">
            <h3 class="km_heading"><?php _e('Billing Address', 'fieldday'); ?></h3>
            <div class="km_billing_wrap">
                <div class="km_col_12 km_field_wrap">
                    <fieldset>
                        <label><?php _e('Address Line 1', 'fieldday'); ?></label>
                        <input class="km_input km_address_1" type="text" name="paymentAddress[line1]" id="km_address_1" data-parsley-required-message="Required" data-parsley-group="<?php echo $step['name']; ?>" required=""/>
                    </fieldset>
                </div>
                <div class="km_col_12 km_field_wrap">
                    <fieldset>
                        <label><?php _e('Address Line 2', 'fieldday'); ?></label>
                        <input type="text" class="km_input km_address_2 km_optional" name="paymentAddress[line2]" id="km_address_2"/>
                    </fieldset>
                </div>
                <div class="km_col_12 km_field_wrap">
                    <fieldset>
                        <label><?php _e('State', 'fieldday'); ?></label>
                        <div class="km_custom_dropdown">
                            <select id="km_addr_state" name="paymentAddress[state]" class="km_input km_addr_state" data-parsley-required-message="Required" data-parsley-group="<?php echo $step['name']; ?>" required="">
                                <option value="" selected>Select....</option>
                                <?php $this->getStatesList(); ?>
                            </select>
                        </div>
                    </fieldset>
                </div>
                <div class="km_col_6 km_field_wrap">
                    <label><?php _e('City', 'fieldday'); ?></label>
                    <input type="text" class="km_input km_addr_city" name="paymentAddress[city]" placeholder="City" id="km_addr_city" data-parsley-required-message="Required" data-parsley-group="<?php echo $step['name']; ?>"  required=""/>
                </div>
                <div class="km_col_6 km_field_wrap">
                    <label><?php _e('Zip Code', 'fieldday'); ?></label>
                    <input type="text" class="km_input km_add_zip" name="paymentAddress[pin]" placeholder="Zip Code" id="km_add_zip" data-parsley-required-message="Required" data-parsley-validation-threshold="1" data-parsley-trigger="keyup" 
    data-parsley-type="digits" required=""/>
                </div>
            </div>

        </div>
    </div> 
    <div class="km_btn_wrap">
        <a href="javascript:void(0);" class="km_next_step km_btn"  onclick="return fieldday.PrevStep();"><?php $this->displayText('atc_prev_btn'); ?></a>
        <a href="javascript:void(0);" class="km_next_step km_btn" data-group="<?php echo $step['name']; ?>" onclick="return fieldday.process_purchaseDetail(this, event);"><?php $this->displayText('atc_next_btn'); ?></a>
    </div>
</div>